/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 79 "cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static void* cmd_tmp;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else 
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 221 "cfg.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DROP = 3,                       /* DROP  */
  YYSYMBOL_ASSERT = 4,                     /* ASSERT  */
  YYSYMBOL_EXIT = 5,                       /* EXIT  */
  YYSYMBOL_RETURN = 6,                     /* RETURN  */
  YYSYMBOL_LOG_TOK = 7,                    /* LOG_TOK  */
  YYSYMBOL_ERROR = 8,                      /* ERROR  */
  YYSYMBOL_ROUTE = 9,                      /* ROUTE  */
  YYSYMBOL_ROUTE_FAILURE = 10,             /* ROUTE_FAILURE  */
  YYSYMBOL_ROUTE_ONREPLY = 11,             /* ROUTE_ONREPLY  */
  YYSYMBOL_ROUTE_BRANCH = 12,              /* ROUTE_BRANCH  */
  YYSYMBOL_ROUTE_ERROR = 13,               /* ROUTE_ERROR  */
  YYSYMBOL_ROUTE_LOCAL = 14,               /* ROUTE_LOCAL  */
  YYSYMBOL_ROUTE_STARTUP = 15,             /* ROUTE_STARTUP  */
  YYSYMBOL_ROUTE_TIMER = 16,               /* ROUTE_TIMER  */
  YYSYMBOL_ROUTE_EVENT = 17,               /* ROUTE_EVENT  */
  YYSYMBOL_IF = 18,                        /* IF  */
  YYSYMBOL_ELSE = 19,                      /* ELSE  */
  YYSYMBOL_SWITCH = 20,                    /* SWITCH  */
  YYSYMBOL_CASE = 21,                      /* CASE  */
  YYSYMBOL_DEFAULT = 22,                   /* DEFAULT  */
  YYSYMBOL_BREAK = 23,                     /* BREAK  */
  YYSYMBOL_WHILE = 24,                     /* WHILE  */
  YYSYMBOL_FOR = 25,                       /* FOR  */
  YYSYMBOL_IN = 26,                        /* IN  */
  YYSYMBOL_NULLV = 27,                     /* NULLV  */
  YYSYMBOL_XDBG = 28,                      /* XDBG  */
  YYSYMBOL_XLOG = 29,                      /* XLOG  */
  YYSYMBOL_XLOG_BUF_SIZE = 30,             /* XLOG_BUF_SIZE  */
  YYSYMBOL_XLOG_FORCE_COLOR = 31,          /* XLOG_FORCE_COLOR  */
  YYSYMBOL_XLOG_PRINT_LEVEL = 32,          /* XLOG_PRINT_LEVEL  */
  YYSYMBOL_XLOG_LEVEL = 33,                /* XLOG_LEVEL  */
  YYSYMBOL_PV_PRINT_BUF_SIZE = 34,         /* PV_PRINT_BUF_SIZE  */
  YYSYMBOL_DEBUG_MODE = 35,                /* DEBUG_MODE  */
  YYSYMBOL_ENABLE_ASSERTS = 36,            /* ENABLE_ASSERTS  */
  YYSYMBOL_ABORT_ON_ASSERT = 37,           /* ABORT_ON_ASSERT  */
  YYSYMBOL_LOGLEVEL = 38,                  /* LOGLEVEL  */
  YYSYMBOL_LOGSTDERROR = 39,               /* LOGSTDERROR  */
  YYSYMBOL_LOGFACILITY = 40,               /* LOGFACILITY  */
  YYSYMBOL_LOGNAME = 41,                   /* LOGNAME  */
  YYSYMBOL_AVP_ALIASES = 42,               /* AVP_ALIASES  */
  YYSYMBOL_LISTEN = 43,                    /* LISTEN  */
  YYSYMBOL_SOCKET = 44,                    /* SOCKET  */
  YYSYMBOL_MEMGROUP = 45,                  /* MEMGROUP  */
  YYSYMBOL_ALIAS = 46,                     /* ALIAS  */
  YYSYMBOL_AUTO_ALIASES = 47,              /* AUTO_ALIASES  */
  YYSYMBOL_TAG = 48,                       /* TAG  */
  YYSYMBOL_DNS = 49,                       /* DNS  */
  YYSYMBOL_REV_DNS = 50,                   /* REV_DNS  */
  YYSYMBOL_DNS_TRY_IPV6 = 51,              /* DNS_TRY_IPV6  */
  YYSYMBOL_DNS_TRY_NAPTR = 52,             /* DNS_TRY_NAPTR  */
  YYSYMBOL_DNS_RETR_TIME = 53,             /* DNS_RETR_TIME  */
  YYSYMBOL_DNS_RETR_NO = 54,               /* DNS_RETR_NO  */
  YYSYMBOL_DNS_SERVERS_NO = 55,            /* DNS_SERVERS_NO  */
  YYSYMBOL_DNS_USE_SEARCH = 56,            /* DNS_USE_SEARCH  */
  YYSYMBOL_MAX_WHILE_LOOPS = 57,           /* MAX_WHILE_LOOPS  */
  YYSYMBOL_UDP_WORKERS = 58,               /* UDP_WORKERS  */
  YYSYMBOL_CHECK_VIA = 59,                 /* CHECK_VIA  */
  YYSYMBOL_SHM_HASH_SPLIT_PERCENTAGE = 60, /* SHM_HASH_SPLIT_PERCENTAGE  */
  YYSYMBOL_SHM_SECONDARY_HASH_SIZE = 61,   /* SHM_SECONDARY_HASH_SIZE  */
  YYSYMBOL_MEM_WARMING_ENABLED = 62,       /* MEM_WARMING_ENABLED  */
  YYSYMBOL_MEM_WARMING_PATTERN_FILE = 63,  /* MEM_WARMING_PATTERN_FILE  */
  YYSYMBOL_MEM_WARMING_PERCENTAGE = 64,    /* MEM_WARMING_PERCENTAGE  */
  YYSYMBOL_RPM_MEM_FILE = 65,              /* RPM_MEM_FILE  */
  YYSYMBOL_RPM_MEM_SIZE = 66,              /* RPM_MEM_SIZE  */
  YYSYMBOL_MEMLOG = 67,                    /* MEMLOG  */
  YYSYMBOL_MEMDUMP = 68,                   /* MEMDUMP  */
  YYSYMBOL_EXECMSGTHRESHOLD = 69,          /* EXECMSGTHRESHOLD  */
  YYSYMBOL_EXECDNSTHRESHOLD = 70,          /* EXECDNSTHRESHOLD  */
  YYSYMBOL_TCPTHRESHOLD = 71,              /* TCPTHRESHOLD  */
  YYSYMBOL_EVENT_SHM_THRESHOLD = 72,       /* EVENT_SHM_THRESHOLD  */
  YYSYMBOL_EVENT_PKG_THRESHOLD = 73,       /* EVENT_PKG_THRESHOLD  */
  YYSYMBOL_QUERYBUFFERSIZE = 74,           /* QUERYBUFFERSIZE  */
  YYSYMBOL_QUERYFLUSHTIME = 75,            /* QUERYFLUSHTIME  */
  YYSYMBOL_SIP_WARNING = 76,               /* SIP_WARNING  */
  YYSYMBOL_SERVER_SIGNATURE = 77,          /* SERVER_SIGNATURE  */
  YYSYMBOL_SERVER_HEADER = 78,             /* SERVER_HEADER  */
  YYSYMBOL_USER_AGENT_HEADER = 79,         /* USER_AGENT_HEADER  */
  YYSYMBOL_LOADMODULE = 80,                /* LOADMODULE  */
  YYSYMBOL_MPATH = 81,                     /* MPATH  */
  YYSYMBOL_MODPARAM = 82,                  /* MODPARAM  */
  YYSYMBOL_MAXBUFFER = 83,                 /* MAXBUFFER  */
  YYSYMBOL_CHROOT = 84,                    /* CHROOT  */
  YYSYMBOL_WDIR = 85,                      /* WDIR  */
  YYSYMBOL_MHOMED = 86,                    /* MHOMED  */
  YYSYMBOL_POLL_METHOD = 87,               /* POLL_METHOD  */
  YYSYMBOL_TCP_ACCEPT_ALIASES = 88,        /* TCP_ACCEPT_ALIASES  */
  YYSYMBOL_TCP_WORKERS = 89,               /* TCP_WORKERS  */
  YYSYMBOL_TCP_CONNECT_TIMEOUT = 90,       /* TCP_CONNECT_TIMEOUT  */
  YYSYMBOL_TCP_CON_LIFETIME = 91,          /* TCP_CON_LIFETIME  */
  YYSYMBOL_TCP_LISTEN_BACKLOG = 92,        /* TCP_LISTEN_BACKLOG  */
  YYSYMBOL_TCP_SOCKET_BACKLOG = 93,        /* TCP_SOCKET_BACKLOG  */
  YYSYMBOL_TCP_MAX_CONNECTIONS = 94,       /* TCP_MAX_CONNECTIONS  */
  YYSYMBOL_TCP_NO_NEW_CONN_BFLAG = 95,     /* TCP_NO_NEW_CONN_BFLAG  */
  YYSYMBOL_TCP_NO_NEW_CONN_RPLFLAG = 96,   /* TCP_NO_NEW_CONN_RPLFLAG  */
  YYSYMBOL_TCP_KEEPALIVE = 97,             /* TCP_KEEPALIVE  */
  YYSYMBOL_TCP_KEEPCOUNT = 98,             /* TCP_KEEPCOUNT  */
  YYSYMBOL_TCP_KEEPIDLE = 99,              /* TCP_KEEPIDLE  */
  YYSYMBOL_TCP_KEEPINTERVAL = 100,         /* TCP_KEEPINTERVAL  */
  YYSYMBOL_TCP_MAX_MSG_TIME = 101,         /* TCP_MAX_MSG_TIME  */
  YYSYMBOL_ADVERTISED_ADDRESS = 102,       /* ADVERTISED_ADDRESS  */
  YYSYMBOL_ADVERTISED_PORT = 103,          /* ADVERTISED_PORT  */
  YYSYMBOL_DISABLE_CORE = 104,             /* DISABLE_CORE  */
  YYSYMBOL_OPEN_FD_LIMIT = 105,            /* OPEN_FD_LIMIT  */
  YYSYMBOL_MCAST_LOOPBACK = 106,           /* MCAST_LOOPBACK  */
  YYSYMBOL_MCAST_TTL = 107,                /* MCAST_TTL  */
  YYSYMBOL_TOS = 108,                      /* TOS  */
  YYSYMBOL_DISABLE_DNS_FAILOVER = 109,     /* DISABLE_DNS_FAILOVER  */
  YYSYMBOL_DISABLE_DNS_BLACKLIST = 110,    /* DISABLE_DNS_BLACKLIST  */
  YYSYMBOL_DST_BLACKLIST = 111,            /* DST_BLACKLIST  */
  YYSYMBOL_DISABLE_STATELESS_FWD = 112,    /* DISABLE_STATELESS_FWD  */
  YYSYMBOL_DB_VERSION_TABLE = 113,         /* DB_VERSION_TABLE  */
  YYSYMBOL_DB_DEFAULT_URL = 114,           /* DB_DEFAULT_URL  */
  YYSYMBOL_DB_MAX_ASYNC_CONNECTIONS = 115, /* DB_MAX_ASYNC_CONNECTIONS  */
  YYSYMBOL_DISABLE_503_TRANSLATION = 116,  /* DISABLE_503_TRANSLATION  */
  YYSYMBOL_SYNC_TOKEN = 117,               /* SYNC_TOKEN  */
  YYSYMBOL_ASYNC_TOKEN = 118,              /* ASYNC_TOKEN  */
  YYSYMBOL_LAUNCH_TOKEN = 119,             /* LAUNCH_TOKEN  */
  YYSYMBOL_AUTO_SCALING_PROFILE = 120,     /* AUTO_SCALING_PROFILE  */
  YYSYMBOL_AUTO_SCALING_CYCLE = 121,       /* AUTO_SCALING_CYCLE  */
  YYSYMBOL_TIMER_WORKERS = 122,            /* TIMER_WORKERS  */
  YYSYMBOL_EQUAL = 123,                    /* EQUAL  */
  YYSYMBOL_EQUAL_T = 124,                  /* EQUAL_T  */
  YYSYMBOL_GT = 125,                       /* GT  */
  YYSYMBOL_LT = 126,                       /* LT  */
  YYSYMBOL_GTE = 127,                      /* GTE  */
  YYSYMBOL_LTE = 128,                      /* LTE  */
  YYSYMBOL_DIFF = 129,                     /* DIFF  */
  YYSYMBOL_MATCH = 130,                    /* MATCH  */
  YYSYMBOL_NOTMATCH = 131,                 /* NOTMATCH  */
  YYSYMBOL_COLONEQ = 132,                  /* COLONEQ  */
  YYSYMBOL_PLUSEQ = 133,                   /* PLUSEQ  */
  YYSYMBOL_MINUSEQ = 134,                  /* MINUSEQ  */
  YYSYMBOL_SLASHEQ = 135,                  /* SLASHEQ  */
  YYSYMBOL_MULTEQ = 136,                   /* MULTEQ  */
  YYSYMBOL_MODULOEQ = 137,                 /* MODULOEQ  */
  YYSYMBOL_BANDEQ = 138,                   /* BANDEQ  */
  YYSYMBOL_BOREQ = 139,                    /* BOREQ  */
  YYSYMBOL_BXOREQ = 140,                   /* BXOREQ  */
  YYSYMBOL_OR = 141,                       /* OR  */
  YYSYMBOL_AND = 142,                      /* AND  */
  YYSYMBOL_BOR = 143,                      /* BOR  */
  YYSYMBOL_BAND = 144,                     /* BAND  */
  YYSYMBOL_BXOR = 145,                     /* BXOR  */
  YYSYMBOL_BLSHIFT = 146,                  /* BLSHIFT  */
  YYSYMBOL_BRSHIFT = 147,                  /* BRSHIFT  */
  YYSYMBOL_PLUS = 148,                     /* PLUS  */
  YYSYMBOL_MINUS = 149,                    /* MINUS  */
  YYSYMBOL_MULT = 150,                     /* MULT  */
  YYSYMBOL_MODULO = 151,                   /* MODULO  */
  YYSYMBOL_NOT = 152,                      /* NOT  */
  YYSYMBOL_BNOT = 153,                     /* BNOT  */
  YYSYMBOL_NUMBER = 154,                   /* NUMBER  */
  YYSYMBOL_ZERO = 155,                     /* ZERO  */
  YYSYMBOL_ID = 156,                       /* ID  */
  YYSYMBOL_STRING = 157,                   /* STRING  */
  YYSYMBOL_SCRIPTVAR = 158,                /* SCRIPTVAR  */
  YYSYMBOL_IPV6ADDR = 159,                 /* IPV6ADDR  */
  YYSYMBOL_IPV4ADDR = 160,                 /* IPV4ADDR  */
  YYSYMBOL_IPNET = 161,                    /* IPNET  */
  YYSYMBOL_COMMA = 162,                    /* COMMA  */
  YYSYMBOL_SEMICOLON = 163,                /* SEMICOLON  */
  YYSYMBOL_RPAREN = 164,                   /* RPAREN  */
  YYSYMBOL_LPAREN = 165,                   /* LPAREN  */
  YYSYMBOL_LBRACE = 166,                   /* LBRACE  */
  YYSYMBOL_RBRACE = 167,                   /* RBRACE  */
  YYSYMBOL_LBRACK = 168,                   /* LBRACK  */
  YYSYMBOL_RBRACK = 169,                   /* RBRACK  */
  YYSYMBOL_SLASH = 170,                    /* SLASH  */
  YYSYMBOL_AS = 171,                       /* AS  */
  YYSYMBOL_USE_WORKERS = 172,              /* USE_WORKERS  */
  YYSYMBOL_USE_AUTO_SCALING_PROFILE = 173, /* USE_AUTO_SCALING_PROFILE  */
  YYSYMBOL_MAX = 174,                      /* MAX  */
  YYSYMBOL_MIN = 175,                      /* MIN  */
  YYSYMBOL_DOT = 176,                      /* DOT  */
  YYSYMBOL_CR = 177,                       /* CR  */
  YYSYMBOL_COLON = 178,                    /* COLON  */
  YYSYMBOL_ANY = 179,                      /* ANY  */
  YYSYMBOL_ANYCAST = 180,                  /* ANYCAST  */
  YYSYMBOL_SCRIPTVARERR = 181,             /* SCRIPTVARERR  */
  YYSYMBOL_SCALE_UP_TO = 182,              /* SCALE_UP_TO  */
  YYSYMBOL_SCALE_DOWN_TO = 183,            /* SCALE_DOWN_TO  */
  YYSYMBOL_ON = 184,                       /* ON  */
  YYSYMBOL_CYCLES = 185,                   /* CYCLES  */
  YYSYMBOL_CYCLES_WITHIN = 186,            /* CYCLES_WITHIN  */
  YYSYMBOL_PERCENTAGE = 187,               /* PERCENTAGE  */
  YYSYMBOL_YYACCEPT = 188,                 /* $accept  */
  YYSYMBOL_cfg = 189,                      /* cfg  */
  YYSYMBOL_statements = 190,               /* statements  */
  YYSYMBOL_statement = 191,                /* statement  */
  YYSYMBOL_192_1 = 192,                    /* $@1  */
  YYSYMBOL_193_2 = 193,                    /* $@2  */
  YYSYMBOL_194_3 = 194,                    /* $@3  */
  YYSYMBOL_195_4 = 195,                    /* $@4  */
  YYSYMBOL_196_5 = 196,                    /* $@5  */
  YYSYMBOL_197_6 = 197,                    /* $@6  */
  YYSYMBOL_198_7 = 198,                    /* $@7  */
  YYSYMBOL_199_8 = 199,                    /* $@8  */
  YYSYMBOL_200_9 = 200,                    /* $@9  */
  YYSYMBOL_listen_id = 201,                /* listen_id  */
  YYSYMBOL_host_sep = 202,                 /* host_sep  */
  YYSYMBOL_host = 203,                     /* host  */
  YYSYMBOL_proto = 204,                    /* proto  */
  YYSYMBOL_port = 205,                     /* port  */
  YYSYMBOL_snumber = 206,                  /* snumber  */
  YYSYMBOL_phostport = 207,                /* phostport  */
  YYSYMBOL_panyhostport = 208,             /* panyhostport  */
  YYSYMBOL_alias_def = 209,                /* alias_def  */
  YYSYMBOL_id_lst = 210,                   /* id_lst  */
  YYSYMBOL_listen_id_def = 211,            /* listen_id_def  */
  YYSYMBOL_socket_def_param = 212,         /* socket_def_param  */
  YYSYMBOL_socket_def_params = 213,        /* socket_def_params  */
  YYSYMBOL_socket_def = 214,               /* socket_def  */
  YYSYMBOL_215_10 = 215,                   /* $@10  */
  YYSYMBOL_216_11 = 216,                   /* $@11  */
  YYSYMBOL_any_proto = 217,                /* any_proto  */
  YYSYMBOL_multi_string = 218,             /* multi_string  */
  YYSYMBOL_blst_elem = 219,                /* blst_elem  */
  YYSYMBOL_blst_elem_list = 220,           /* blst_elem_list  */
  YYSYMBOL_auto_scale_profile_def = 221,   /* auto_scale_profile_def  */
  YYSYMBOL_assign_stm = 222,               /* assign_stm  */
  YYSYMBOL_module_stm = 223,               /* module_stm  */
  YYSYMBOL_ip = 224,                       /* ip  */
  YYSYMBOL_ipv4 = 225,                     /* ipv4  */
  YYSYMBOL_ipv6addr = 226,                 /* ipv6addr  */
  YYSYMBOL_ipv6 = 227,                     /* ipv6  */
  YYSYMBOL_ipnet = 228,                    /* ipnet  */
  YYSYMBOL_folded_string = 229,            /* folded_string  */
  YYSYMBOL_route_name = 230,               /* route_name  */
  YYSYMBOL_route_name_var = 231,           /* route_name_var  */
  YYSYMBOL_route_stm = 232,                /* route_stm  */
  YYSYMBOL_failure_route_stm = 233,        /* failure_route_stm  */
  YYSYMBOL_onreply_route_stm = 234,        /* onreply_route_stm  */
  YYSYMBOL_branch_route_stm = 235,         /* branch_route_stm  */
  YYSYMBOL_error_route_stm = 236,          /* error_route_stm  */
  YYSYMBOL_local_route_stm = 237,          /* local_route_stm  */
  YYSYMBOL_startup_route_stm = 238,        /* startup_route_stm  */
  YYSYMBOL_timer_route_stm = 239,          /* timer_route_stm  */
  YYSYMBOL_event_route_stm = 240,          /* event_route_stm  */
  YYSYMBOL_exp = 241,                      /* exp  */
  YYSYMBOL_equalop = 242,                  /* equalop  */
  YYSYMBOL_compop = 243,                   /* compop  */
  YYSYMBOL_matchop = 244,                  /* matchop  */
  YYSYMBOL_intop = 245,                    /* intop  */
  YYSYMBOL_strop = 246,                    /* strop  */
  YYSYMBOL_script_var = 247,               /* script_var  */
  YYSYMBOL_exp_elem = 248,                 /* exp_elem  */
  YYSYMBOL_exp_cond = 249,                 /* exp_cond  */
  YYSYMBOL_assignop = 250,                 /* assignop  */
  YYSYMBOL_assignexp = 251,                /* assignexp  */
  YYSYMBOL_assign_cmd = 252,               /* assign_cmd  */
  YYSYMBOL_exp_stm = 253,                  /* exp_stm  */
  YYSYMBOL_brk_stm = 254,                  /* brk_stm  */
  YYSYMBOL_stm = 255,                      /* stm  */
  YYSYMBOL_actions = 256,                  /* actions  */
  YYSYMBOL_brk_actions = 257,              /* brk_actions  */
  YYSYMBOL_action = 258,                   /* action  */
  YYSYMBOL_brk_action = 259,               /* brk_action  */
  YYSYMBOL_brk_if_cmd = 260,               /* brk_if_cmd  */
  YYSYMBOL_if_cmd = 261,                   /* if_cmd  */
  YYSYMBOL_while_cmd = 262,                /* while_cmd  */
  YYSYMBOL_foreach_cmd = 263,              /* foreach_cmd  */
  YYSYMBOL_switch_cmd = 264,               /* switch_cmd  */
  YYSYMBOL_switch_stm = 265,               /* switch_stm  */
  YYSYMBOL_case_stms = 266,                /* case_stms  */
  YYSYMBOL_case_stm = 267,                 /* case_stm  */
  YYSYMBOL_default_stm = 268,              /* default_stm  */
  YYSYMBOL_func_param = 269,               /* func_param  */
  YYSYMBOL_route_param = 270,              /* route_param  */
  YYSYMBOL_async_func = 271,               /* async_func  */
  YYSYMBOL_cmd = 272                       /* cmd  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  204
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2044

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  188
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  85
/* YYNRULES -- Number of rules.  */
#define YYNRULES  468
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  898

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   442


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   479,   479,   482,   483,   484,   487,   488,   489,   489,
     490,   490,   491,   491,   492,   492,   493,   493,   494,   494,
     495,   495,   496,   496,   497,   497,   499,   502,   517,   526,
     541,   542,   545,   546,   560,   565,   575,   576,   579,   580,
     581,   585,   587,   589,   594,   600,   602,   606,   608,   610,
     612,   616,   619,   620,   623,   625,   627,   633,   636,   639,
     642,   645,   650,   651,   654,   655,   656,   656,   661,   661,
     668,   669,   671,   672,   675,   683,   694,   695,   696,   700,
     708,   716,   722,   730,   734,   735,   736,   737,   738,   742,
     744,   748,   749,   755,   756,   757,   758,   759,   760,   761,
     762,   763,   764,   765,   766,   767,   768,   769,   770,   771,
     772,   773,   774,   775,   776,   777,   778,   779,   783,   784,
     787,   791,   792,   793,   801,   809,   817,   825,   833,   841,
     849,   857,   865,   873,   876,   877,   880,   881,   882,   883,
     884,   885,   886,   887,   888,   889,   890,   891,   901,   902,
     916,   917,   918,   919,   920,   921,   922,   923,   924,   925,
     926,   927,   928,   929,   930,   931,   941,   951,   952,   955,
     956,   959,   963,   964,   967,   968,   971,   972,   976,   977,
     980,   981,   984,   985,   992,   993,  1000,  1002,  1005,  1006,
    1009,  1010,  1017,  1018,  1025,  1026,  1033,  1034,  1036,  1037,
    1041,  1042,  1045,  1046,  1048,  1049,  1051,  1053,  1055,  1056,
    1057,  1058,  1060,  1061,  1068,  1071,  1079,  1082,  1126,  1127,
    1132,  1134,  1136,  1137,  1143,  1145,  1159,  1161,  1164,  1165,
    1168,  1169,  1176,  1177,  1184,  1185,  1189,  1217,  1218,  1220,
    1221,  1224,  1225,  1228,  1229,  1239,  1241,  1243,  1244,  1246,
    1247,  1249,  1252,  1254,  1257,  1258,  1261,  1263,  1266,  1269,
    1273,  1274,  1280,  1286,  1290,  1291,  1294,  1310,  1326,  1327,
    1330,  1336,  1346,  1356,  1367,  1370,  1379,  1384,  1407,  1412,
    1420,  1436,  1439,  1445,  1448,  1456,  1462,  1465,  1471,  1474,
    1482,  1485,  1493,  1496,  1504,  1507,  1519,  1522,  1528,  1533,
    1534,  1535,  1536,  1537,  1538,  1541,  1542,  1545,  1546,  1547,
    1548,  1550,  1551,  1554,  1555,  1558,  1559,  1560,  1563,  1579,
    1584,  1585,  1586,  1588,  1593,  1596,  1599,  1602,  1605,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1624,
    1625,  1626,  1627,  1628,  1629,  1632,  1635,  1638,  1641,  1644,
    1647,  1650,  1653,  1656,  1659,  1662,  1665,  1678,  1691,  1713,
    1714,  1715,  1716,  1717,  1720,  1721,  1722,  1725,  1726,  1727,
    1730,  1731,  1732,  1736,  1737,  1738,  1741,  1742,  1743,  1744,
    1745,  1746,  1747,  1748,  1751,  1752,  1753,  1754,  1755,  1756,
    1757,  1758,  1759,  1762,  1770,  1780,  1788,  1798,  1806,  1824,
    1833,  1834,  1836,  1837,  1840,  1846,  1852,  1858,  1866,  1869,
    1872,  1877,  1887,  1894,  1901,  1911,  1916,  1923,  1933,  1938,
    1945,  1957,  1962,  1967,  1972,  1977,  1987,  1997,  2007,  2019,
    2037,  2068,  2072,  2078,  2081,  2082,  2083,  2084,  2085,  2087,
    2089,  2091,  2093,  2095,  2096,  2099,  2105,  2106,  2108,  2114,
    2115,  2117,  2121,  2140,  2141,  2143,  2166,  2202,  2204,  2207,
    2209,  2211,  2213,  2215,  2217,  2219,  2225,  2231,  2237
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DROP", "ASSERT",
  "EXIT", "RETURN", "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL",
  "ROUTE_STARTUP", "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH",
  "CASE", "DEFAULT", "BREAK", "WHILE", "FOR", "IN", "NULLV", "XDBG",
  "XLOG", "XLOG_BUF_SIZE", "XLOG_FORCE_COLOR", "XLOG_PRINT_LEVEL",
  "XLOG_LEVEL", "PV_PRINT_BUF_SIZE", "DEBUG_MODE", "ENABLE_ASSERTS",
  "ABORT_ON_ASSERT", "LOGLEVEL", "LOGSTDERROR", "LOGFACILITY", "LOGNAME",
  "AVP_ALIASES", "LISTEN", "SOCKET", "MEMGROUP", "ALIAS", "AUTO_ALIASES",
  "TAG", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "MAX_WHILE_LOOPS", "UDP_WORKERS", "CHECK_VIA",
  "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD", "TCPTHRESHOLD",
  "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD", "QUERYBUFFERSIZE",
  "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER",
  "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM", "MAXBUFFER",
  "CHROOT", "WDIR", "MHOMED", "POLL_METHOD", "TCP_ACCEPT_ALIASES",
  "TCP_WORKERS", "TCP_CONNECT_TIMEOUT", "TCP_CON_LIFETIME",
  "TCP_LISTEN_BACKLOG", "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS",
  "TCP_NO_NEW_CONN_BFLAG", "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE",
  "TCP_KEEPCOUNT", "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "MCAST_LOOPBACK", "MCAST_TTL", "TOS", "DISABLE_DNS_FAILOVER",
  "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST", "DISABLE_STATELESS_FWD",
  "DB_VERSION_TABLE", "DB_DEFAULT_URL", "DB_MAX_ASYNC_CONNECTIONS",
  "DISABLE_503_TRANSLATION", "SYNC_TOKEN", "ASYNC_TOKEN", "LAUNCH_TOKEN",
  "AUTO_SCALING_PROFILE", "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL",
  "EQUAL_T", "GT", "LT", "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH",
  "COLONEQ", "PLUSEQ", "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ",
  "BANDEQ", "BOREQ", "BXOREQ", "OR", "AND", "BOR", "BAND", "BXOR",
  "BLSHIFT", "BRSHIFT", "PLUS", "MINUS", "MULT", "MODULO", "NOT", "BNOT",
  "NUMBER", "ZERO", "ID", "STRING", "SCRIPTVAR", "IPV6ADDR", "IPV4ADDR",
  "IPNET", "COMMA", "SEMICOLON", "RPAREN", "LPAREN", "LBRACE", "RBRACE",
  "LBRACK", "RBRACK", "SLASH", "AS", "USE_WORKERS",
  "USE_AUTO_SCALING_PROFILE", "MAX", "MIN", "DOT", "CR", "COLON", "ANY",
  "ANYCAST", "SCRIPTVARERR", "SCALE_UP_TO", "SCALE_DOWN_TO", "ON",
  "CYCLES", "CYCLES_WITHIN", "PERCENTAGE", "$accept", "cfg", "statements",
  "statement", "$@1", "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "listen_id", "host_sep", "host", "proto", "port", "snumber",
  "phostport", "panyhostport", "alias_def", "id_lst", "listen_id_def",
  "socket_def_param", "socket_def_params", "socket_def", "$@10", "$@11",
  "any_proto", "multi_string", "blst_elem", "blst_elem_list",
  "auto_scale_profile_def", "assign_stm", "module_stm", "ip", "ipv4",
  "ipv6addr", "ipv6", "ipnet", "folded_string", "route_name",
  "route_name_var", "route_stm", "failure_route_stm", "onreply_route_stm",
  "branch_route_stm", "error_route_stm", "local_route_stm",
  "startup_route_stm", "timer_route_stm", "event_route_stm", "exp",
  "equalop", "compop", "matchop", "intop", "strop", "script_var",
  "exp_elem", "exp_cond", "assignop", "assignexp", "assign_cmd", "exp_stm",
  "brk_stm", "stm", "actions", "brk_actions", "action", "brk_action",
  "brk_if_cmd", "if_cmd", "while_cmd", "foreach_cmd", "switch_cmd",
  "switch_stm", "case_stms", "case_stm", "default_stm", "func_param",
  "route_param", "async_func", "cmd", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442
};
#endif

#define YYPACT_NINF (-762)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-409)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1867,   -79,   -37,   -26,   -20,    -6,    11,    14,    33,   218,
     222,   238,   290,   301,   310,   357,   379,   428,   470,   478,
     483,   323,   339,   341,   380,   536,   589,   512,   520,   521,
     535,   544,   553,   571,   578,   590,   603,   611,   619,   621,
     643,   646,   657,   659,   662,   663,   668,   675,   682,   683,
      50,   685,    27,   696,   698,   699,   700,   701,   703,   709,
     713,   725,   727,   728,   732,   734,   736,   737,   741,   742,
     748,   759,   763,   767,   768,   772,   773,   781,   789,   596,
     622,   791,   802,   803,   806,   807,   815,   818,   825,   836,
    -762,   519,  1738,  -762,   348,   799,   552,   628,   739,   821,
     945,   947,   944,  -762,  -762,  -762,    90,   237,   328,   333,
     346,   352,   363,   366,   260,   367,   309,   120,   234,   318,
     805,   242,   368,   369,   370,  -762,   814,  -762,   819,  -762,
     832,  -762,   835,  -762,   837,  -762,   839,   372,   393,   394,
     396,   402,   414,   121,   425,   122,   438,   307,   347,   440,
     448,   453,   457,   466,   467,   468,   503,   506,   123,   154,
    -762,  -762,   159,  -762,   840,   517,   100,   117,   538,   119,
     551,   563,   568,   577,   579,   581,   623,   317,   327,   627,
     629,   630,   635,   638,   145,   640,   641,   645,   674,   676,
     325,  -762,   841,  -762,   848,   854,   857,   160,   166,   677,
     686,   337,   695,   860,  -762,   -79,  -762,    19,  -762,    10,
    -762,    38,  -762,    25,  -762,    45,  -762,    62,  -762,    64,
    -762,    29,  -762,    37,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,   872,   876,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,   991,  -762,   866,   -33,   681,  -762,  -762,  -762,
     867,  -762,   868,  -762,  -762,  -762,   888,   870,  -762,   -95,
     871,  -762,   263,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,   878,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,   891,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,   882,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,   879,  -762,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,   884,
    -762,  -762,  -762,   883,  -762,  1579,   647,  -762,   647,  -762,
    1579,   647,  -762,   647,  -762,  1579,  -762,  1579,  -762,  1579,
    -762,   647,  -762,   647,  -762,  -762,  -762,   856,   712,   712,
     189,   892,   861,  -762,   338,   904,   861,  -762,   911,   912,
     914,   902,   918,   919,   909,   916,   928,   -23,    60,    72,
      81,   929,   930,   932,   933,   934,   935,   936,   938,    86,
    -762,  -762,  -762,  1207,   913,   644,  -762,  -762,  -762,  -762,
    -762,    84,  -762,  -762,  -762,   908,   910,   750,   937,   939,
     809,   838,   869,   921,   952,   948,   950,   924,   861,   953,
     954,  -762,   712,  -762,  -762,  -762,   965,  -762,  -762,   955,
    -762,  -762,  -762,   961,  -762,   -96,   940,  -762,   966,  1307,
     968,   751,  -762,  -762,  -762,   173,  -762,   197,  -762,    61,
    1307,   -65,  1307,   -65,   977,   980,   969,   969,  -762,    22,
    1115,  1123,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
     567,  -762,  -762,  -762,  -762,  -762,  -762,   972,   985,  -762,
     988,   989,  -762,  -762,  -762,  1002,   993,  -122,    12,  -762,
     979,  -762,  -762,  -762,  -762,  -762,    35,   303,   996,   233,
    -762,    67,  1008,  -762,  1307,  1307,  1442,   567,  -762,     3,
    1868,  -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,   999,
    1003,  1006,  1007,  1004,  1009,  1031,  1030,  -762,   -56,  -762,
     -92,  1038,   -14,  1172,   215,   286,   527,   497,    87,  1041,
     -21,  1040,  -762,   753,  -762,  -762,  -762,   169,  -762,  -762,
     567,  -762,   567,  -762,  1057,  -762,  1062,  -762,  1579,  1579,
    1579,  1579,  1054,  1579,  -762,  -762,  -762,  -762,  -762,    41,
    -762,  -762,  1060,  1061,   233,  -762,  -762,  1064,  -762,   -96,
    -762,  1076,  -762,   221,  -762,   915,   834,  1307,  1307,  1071,
    -762,  -762,  -762,  -762,  -762,  -762,  -762,  -762,   522,   -48,
    -762,   260,   -45,  -762,  -762,  -762,  -762,  1077,  -762,  1078,
    -762,   592,  -762,  1473,  1070,  1277,   -65,  -762,  -762,  -762,
    -762,  1082,  -762,  -762,  -762,    91,   647,   647,  -762,  -762,
    -762,  -762,  -762,   788,  -762,  -762,   941,   567,   567,   567,
     567,   567,   567,   567,   567,   567,   567,   946,  1034,  1111,
    1140,  1074,  1171,  -762,  -762,  -762,  -762,  1081,   720,  -762,
    1219,  -762,  -762,  -762,  -762,  -762,  1083,  -762,  -762,  -762,
    -762,  -762,  -762,  -762,  1084,  1086,  -762,  -762,  -762,  -762,
     270,  1515,  1226,  -762,  1225,  1095,  1098,  -762,  1350,  1099,
    -762,  -762,  -762,  -762,  -762,  -762,    97,  1100,   550,   607,
    1101,  -762,   283,   575,  1106,  -762,  -762,  -762,  -762,   560,
     560,   560,   560,   560,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  1579,  -762,   720,  1109,  1121,  -762,  -762,
    -762,   639,  -762,  -762,  1213,  1473,   874,  1096,    31,  -762,
    1307,  -762,  -762,   580,  -762,  -762,  -762,  -762,  1277,  -762,
    -762,  -762,  -762,  1125,  -762,  -762,  1248,  1126,  -122,   151,
    -762,  -762,  -762,  -762,  -762,  -762,  1113,  1116,  -762,  1130,
    -762,  -762,   236,  -762,  -762,  -762,  -762,  1129,  -762,  -122,
    1137,  1104,  1150,  1544,  1544,  1544,  1277,  -762,  1147,  1160,
    1164,  1136,   507,   537,   609,  1301,  1165,  1159,  1142,  1170,
    1277,  1169,  -762,  1174,  1153,  -762,  -762,  1197,  1195,  1325,
    1200,  1206,  1336,  1177,  1209,  -762,  1179,  -762
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      26,     0,     0,     4,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     6,     7,   258,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   101,     0,   103,     0,   105,
       0,   107,     0,   109,     0,   111,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     260,   259,     0,   263,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   241,     0,   243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     5,     3,     0,     9,     0,
      11,     0,    13,     0,    15,     0,    17,     0,    19,     0,
      21,     0,    23,     0,    25,   208,   205,   209,   206,   210,
     207,   212,   211,   204,   203,    89,    88,    85,    84,    87,
      86,     0,     0,    38,    83,    91,    90,    93,    92,    95,
      94,   216,     0,    35,     0,    65,    64,   215,   214,   213,
       0,   220,    32,    28,   267,   266,     0,     0,    47,    29,
       0,    51,    52,   219,    27,   264,   268,   265,   222,   221,
      97,    96,    99,    98,   100,   102,   104,   106,   108,   110,
     113,   112,   118,   116,   122,   121,   124,   123,   126,   125,
     128,   127,   130,   129,   132,   131,   134,   133,   136,   135,
     138,   137,   140,   139,   142,   141,   144,   143,   146,   145,
     148,   147,   150,   149,   152,   151,   154,   153,   156,   155,
     198,   197,   200,   199,   202,   201,   239,   238,     0,   115,
     114,   159,   158,   157,   162,   161,   160,   164,   163,   167,
     165,   166,   169,   168,   172,   170,   174,   173,   176,   175,
     178,   177,   180,   179,   182,   181,   184,   183,   186,   185,
     188,   187,   192,   191,   194,   193,   196,   195,   190,   189,
     224,    32,   223,   226,   225,   228,   227,   230,   229,   232,
     231,   234,   233,   237,   235,   236,   240,   242,     0,   245,
     247,   246,   249,   248,   251,   250,   253,   252,   255,     0,
     254,   257,   256,   119,   281,     0,     0,   283,     0,   286,
       0,     0,   288,     0,   290,     0,   292,     0,   294,     0,
     296,     0,   298,     0,    39,    40,    44,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,    53,     0,     0,
       0,     0,     0,     0,   434,     0,   436,   443,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     318,   382,   319,     0,     0,     0,   371,   377,   378,   379,
     380,     0,   275,   274,   276,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    41,     0,     0,     0,
       0,    57,    62,    69,    67,   218,    72,   217,   269,    48,
      34,    33,   117,     0,   171,     0,     0,   120,     0,     0,
       0,     0,   440,   438,   446,     0,   449,     0,   453,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   458,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
       0,   381,   372,   279,   370,   383,   376,     0,     0,   284,
       0,     0,   289,   291,   293,     0,     0,     0,     0,    60,
      54,    59,    58,    61,    63,    73,     0,     0,     0,     0,
      77,     0,     0,   435,     0,     0,     0,     0,   322,     0,
     323,   304,   320,   361,   321,   360,   359,   437,   442,     0,
       0,     0,     0,     0,     0,     0,     0,   277,     0,   278,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   410,   412,   455,   415,   418,     0,   357,   358,
       0,   340,     0,   339,   341,   342,   356,   343,     0,     0,
       0,     0,     0,     0,    36,    37,    46,    43,    42,     0,
      50,    49,     0,     0,     0,    70,    71,     0,    78,     0,
     244,     0,   301,     0,   363,     0,     0,     0,     0,     0,
     305,   307,   308,   309,   310,   306,   311,   312,   313,   314,
     317,     0,     0,   441,   439,   447,   444,     0,   450,     0,
     454,     0,   451,     0,     0,     0,     0,   272,   459,   273,
     460,     0,   461,   462,   432,     0,     0,     0,   468,   457,
     413,   416,   419,   414,   456,   354,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    56,    55,   261,   262,     0,     0,    76,
       0,   302,   362,   303,   300,   299,     0,   327,   270,   271,
     328,   326,   325,   324,     0,     0,   423,   421,   422,   424,
       0,     0,   395,   367,     0,     0,     0,   391,     0,     0,
     397,   364,   386,   387,   388,   389,     0,     0,     0,     0,
       0,   429,     0,     0,     0,   411,   417,   420,   355,   350,
     349,   351,   352,   353,   344,   345,   346,   348,   347,   280,
     282,   285,   287,     0,   297,     0,     0,     0,   433,   445,
     448,     0,   452,   369,     0,     0,     0,     0,   401,   403,
       0,   384,   366,     0,   374,   390,   392,   385,     0,   463,
     464,   431,   430,     0,   465,   467,     0,     0,     0,     0,
     428,   425,   426,   427,   368,   396,     0,     0,   399,     0,
     402,   400,     0,   375,   365,   373,   398,     0,   295,     0,
       0,    82,     0,   407,   405,   409,     0,   466,     0,     0,
       0,    81,     0,     0,     0,   393,     0,     0,     0,     0,
       0,     0,    74,     0,     0,   394,    75,     0,     0,     0,
       0,     0,     0,     0,     0,    80,     0,    79
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -762,  -762,  -762,  1273,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -143,  -762,  -762,  -120,  -547,  -114,  -115,
    -762,  -762,  1105,  -762,  -762,  -391,  1253,  -762,  -762,   729,
     875,   723,  -762,  -762,  -762,  -762,  -272,  -762,  1118,  -762,
    -698,  -513,  -414,  -762,  -762,  -762,  -762,  -762,  -762,  -762,
    -762,  -762,  -762,  -485,  -762,  -762,  -762,  -762,  -762,  -455,
    -762,  -505,  -762,   896,  -514,  -762,  -761,   570,  -417,  -489,
    -432,   135,  -762,  -495,  -664,  -388,  -375,  -762,  -762,   569,
    -762,   684,  -762,   849,  -436
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   268,   445,   269,   254,   646,   633,   255,
     256,   272,   273,   571,   502,   503,   257,   439,   438,   657,
     507,   580,   581,   410,   103,   104,   274,   275,   276,   277,
     750,   615,   485,   608,   208,   210,   212,   214,   216,   218,
     220,   222,   224,   589,   678,   679,   680,   681,   682,   473,
     591,   635,   550,   636,   474,   594,   770,   762,   475,   823,
     476,   771,   772,   477,   478,   479,   480,   817,   818,   819,
     851,   627,   760,   619,   481
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     244,   270,   523,   487,   486,   593,   271,   488,   490,   489,
     491,   417,   492,   647,   592,   -68,   593,   493,   593,   494,
     414,   648,   617,   621,   595,   592,   422,   592,   163,   651,
     430,   773,   644,   311,   313,   595,   650,   595,   432,   419,
     806,   382,   733,   554,   105,   610,   424,   612,   504,   667,
     668,   160,   816,   849,   443,   554,   578,   645,   554,   554,
     554,   524,   606,   426,   590,   428,   600,   856,   658,   579,
     593,   593,   693,   526,   609,   590,   611,   590,   613,   592,
     592,   444,   528,   596,   626,   555,   106,   538,   704,   595,
     595,   225,   780,   470,   596,   634,   596,   107,   826,   662,
     663,   341,   734,   108,   773,   875,   691,   837,   692,  -316,
    -316,   574,   752,   470,   637,   607,   472,   109,   344,   885,
     349,   249,   302,   306,   332,   241,   242,   667,   668,   590,
     590,   243,   634,  -316,   110,   470,   472,   111,   -68,   -68,
     -68,   707,   521,   708,   667,   668,   380,   -68,   596,   596,
     695,   637,   270,   593,   593,   334,   112,   271,   472,   773,
     336,   400,   592,   592,   773,   669,   644,   402,   712,   665,
     241,   242,   595,   595,   601,   634,   243,   634,   418,   622,
     470,   769,   744,   745,   623,   415,   624,   416,   779,   644,
     505,   645,   164,   423,   637,   644,   637,   431,   604,   773,
     773,   773,   773,   472,   420,   433,   421,   161,   773,   773,
     773,   425,   590,   590,   645,   482,   773,   483,   484,   470,
     645,   727,   728,   729,   730,   525,   732,   753,   427,   659,
     429,   596,   596,   554,   660,   251,   759,   527,   227,   241,
     242,   777,   472,   261,   226,   243,   529,   556,   622,   470,
     626,   539,   705,   623,   769,   781,   342,   343,   787,   776,
     827,   763,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   472,   345,   346,   350,   351,   250,   303,   307,
     333,   637,   637,   637,   637,   637,   637,   637,   637,   637,
     637,   860,   783,   784,   496,   554,   554,   554,   554,   509,
     554,   381,   263,   496,   264,   265,   593,   774,   310,   769,
     247,   335,   868,   266,   769,   592,   337,   401,   366,   258,
     775,   241,   242,   403,   125,   595,   393,   243,   368,   229,
     602,   713,   776,   714,   231,   852,   861,   862,   408,   510,
     127,   113,   129,   522,   814,   114,   506,   233,   312,   769,
     769,   769,   769,   235,   605,   570,   843,   207,   769,   769,
     769,   115,   667,   668,   237,   590,   769,   239,   245,   278,
     280,   282,   697,   290,   872,   873,   874,   667,   668,   698,
     774,   131,   554,   763,   596,   741,   836,   776,   252,   253,
     253,   228,   776,   775,   292,   294,   252,   296,   262,   263,
     866,   264,   265,   298,   554,   588,   749,   599,   241,   242,
     266,   603,   655,   116,   243,   300,   588,   252,   588,   262,
     263,   267,   264,   265,   117,   625,   304,   776,   776,   776,
     776,   266,   811,   118,   812,   774,   776,   776,   776,   308,
     774,   314,   267,   699,   776,   713,   126,   832,   775,   316,
     700,   241,   242,   775,   318,   241,   242,   243,   320,   656,
     652,   243,   128,   653,   130,   248,   749,   322,   324,   326,
     588,   588,   252,   367,   253,   774,   774,   774,   774,   394,
     119,   395,   230,   369,   774,   774,   774,   232,   775,   775,
     775,   775,   774,   409,   -30,   241,   242,   775,   775,   775,
     234,   243,   120,   132,   328,   775,   236,   330,   853,   711,
     454,   455,   456,   457,   458,   459,   460,   238,   339,   204,
     240,   246,   279,   281,   283,   765,   291,   462,  -406,  -406,
     766,   463,   464,   749,   656,   465,   466,   133,   853,   347,
     454,   455,   456,   457,   458,   459,   460,   293,   295,   747,
     297,   121,   352,   588,   588,   765,   299,   462,  -404,  -404,
     766,   463,   464,   211,   354,   465,   466,   751,   301,   356,
     454,   455,   456,   457,   458,   459,   460,   758,   358,   305,
     360,   853,   362,   454,   455,   456,   457,   458,   459,   460,
     135,   625,   309,   122,   315,   465,   466,   191,   765,   786,
     462,   123,   317,   766,   463,   464,   124,   319,   465,   466,
     853,   321,   454,   455,   456,   457,   458,   459,   460,   756,
     323,   325,   327,   193,   364,   467,   468,   765,   370,   462,
     372,   374,   766,   463,   464,   137,   376,   465,   466,   378,
     213,   383,   385,   138,   139,   552,   387,   454,   455,   456,
     457,   458,   459,   460,   699,   467,   468,   329,   140,   134,
     331,   703,   461,   469,   462,   470,   840,   141,   463,   464,
     767,   340,   465,   466,  -406,   389,   142,   391,   404,  -315,
    -315,   264,   265,   748,   697,   467,   468,   406,   472,   701,
     266,   702,   348,   469,   143,   470,   411,   842,   467,   468,
     767,   144,   847,  -315,  -404,   353,   588,   697,   722,   723,
     724,   725,   136,   145,   829,   241,   242,   355,   472,   192,
     630,   243,   357,   469,   631,   470,   146,   467,   468,   -66,
     726,   359,   632,   361,   147,   363,   469,   833,   470,   834,
     241,   242,   148,   767,   149,   194,   243,   854,   472,   757,
     470,   552,   215,   454,   455,   456,   457,   458,   459,   460,
     497,   472,   467,   468,   699,   469,   150,   470,   461,   151,
     462,   830,   767,   472,   463,   464,  -408,   365,   465,   466,
     152,   371,   153,   373,   375,   154,   155,   241,   242,   377,
     472,   156,   379,   243,   384,   386,   841,   470,   157,   388,
     469,   482,   470,   483,   484,   158,   159,   471,   162,   209,
     552,   553,   454,   455,   456,   457,   458,   459,   460,   165,
     472,   166,   167,   168,   169,   472,   170,   461,   390,   462,
     392,   405,   171,   463,   464,   217,   172,   465,   466,   552,
     407,   454,   455,   456,   457,   458,   459,   460,   173,   412,
     174,   175,   -66,   -66,   -66,   176,   461,   177,   462,   178,
     179,   -66,   463,   464,   180,   181,   465,   466,   467,   468,
     552,   182,   454,   455,   456,   457,   458,   459,   460,   264,
     265,   748,   183,   498,   499,   500,   184,   461,   266,   462,
     185,   186,   501,   463,   464,   187,   188,   465,   466,   241,
     242,   241,   242,   824,   189,   243,   469,   243,   470,   470,
     710,   470,   190,   471,   195,   598,   552,   559,   454,   455,
     456,   457,   458,   459,   460,   196,   197,   467,   468,   198,
     199,   472,   472,   461,   472,   462,   241,   242,   200,   463,
     464,   201,   243,   465,   466,   785,   470,   552,   202,   454,
     455,   456,   457,   458,   459,   460,   467,   468,   855,   203,
     219,   223,   260,   221,   461,   469,   462,   470,   284,   472,
     463,   464,   471,   285,   465,   466,   562,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   286,   467,   468,   287,
     472,   288,   436,   289,   469,   396,   470,   338,   824,   824,
     824,   471,   397,   743,   726,   563,   495,   855,   855,   855,
     398,   399,   381,   263,   413,   264,   265,   381,   263,   472,
     264,   265,   241,   242,   266,   469,   434,   470,   243,   266,
     435,   846,   471,   467,   468,   552,   564,   454,   455,   456,
     457,   458,   459,   460,   437,   440,   -35,   264,   442,   446,
     472,   448,   461,   449,   462,   450,   453,   451,   463,   464,
     511,   508,   465,   466,   467,   468,   452,   512,   515,   513,
     514,   469,   516,   470,   518,   517,   551,   557,   471,   558,
     569,   519,   742,   565,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   520,   530,   531,   472,   532,   533,   534,
     535,   536,   469,   537,   470,   788,   560,   572,   561,   471,
     573,   726,   552,   799,   454,   455,   456,   457,   458,   459,
     460,   566,   506,   577,   582,   618,   567,   472,   568,   461,
     583,   462,   597,   576,   614,   463,   464,   616,   638,   465,
     466,   552,   628,   454,   455,   456,   457,   458,   459,   460,
     629,   639,   467,   468,   640,   641,   642,   649,   461,   643,
     462,   654,   661,   683,   463,   464,   687,   684,   465,   466,
     685,   686,   552,   688,   454,   455,   456,   457,   458,   459,
     460,   670,   671,   672,   673,   674,   675,   676,   677,   461,
     469,   462,   470,   689,   690,   463,   464,   471,   696,   465,
     466,   800,   694,   706,   709,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   552,   472,   454,   455,   456,   457,
     458,   459,   460,   731,   735,   736,   738,   740,   746,   467,
     468,   461,   726,   462,   754,   755,   764,   463,   464,   778,
     803,   465,   466,   805,   807,   815,   816,   808,   809,   552,
     810,   454,   455,   456,   457,   458,   459,   460,   467,   468,
     820,   821,   825,   848,   828,   831,   461,   469,   462,   470,
     835,   838,   463,   464,   471,   839,   465,   466,   801,   857,
     454,   455,   456,   457,   458,   459,   460,   870,   859,   467,
     468,   863,   472,   867,   864,   765,   469,   462,   470,   869,
     766,   463,   464,   471,   871,   465,   466,   802,   865,   876,
     454,   455,   456,   457,   458,   459,   460,   877,   878,   879,
     880,   472,   881,   882,   884,   461,   883,   469,   887,   470,
     540,   467,   468,   886,   471,   465,   466,   888,   804,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   889,   890,
     891,   892,   472,   454,   455,   456,   457,   458,   459,   460,
     893,   894,   895,   896,   897,   206,   467,   468,   765,   469,
     462,   470,   259,   766,   463,   464,   471,   447,   465,   466,
     844,   575,   739,   737,   441,   845,   620,   850,     0,   782,
       0,     0,     0,     0,   472,   467,   468,     0,     0,     0,
       0,     0,     0,     0,   469,     0,   470,     0,     0,     0,
       0,   471,     0,     0,     0,   858,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   467,   468,     0,     0,   472,
       0,     0,     0,   469,     0,   470,     0,     0,     0,     0,
     767,     0,     0,   768,     0,   454,   455,   456,   457,   458,
     459,   460,     0,     0,     0,   241,   242,     0,   472,   584,
     461,   243,   462,   469,     0,   470,   463,   464,   467,   468,
     465,   466,   585,   586,     0,   587,   454,   455,   456,   457,
     458,   459,   460,   666,     0,     0,     0,     0,   472,     0,
       0,   461,     0,   462,     0,     0,     0,   463,   464,     0,
       0,   465,   466,     0,     0,     0,   469,     0,   470,     0,
       0,     0,     0,   767,     0,     0,     0,   822,   454,   455,
     456,   457,   458,   459,   460,     0,   715,     0,   716,     0,
       0,   472,     0,   461,     0,   462,     0,     0,     0,   463,
     464,     0,     0,   465,   466,     0,     0,   454,   455,   456,
     457,   458,   459,   460,     0,     0,     0,     0,     0,     0,
     467,   468,   765,     0,   462,     0,     0,   766,   463,   464,
       0,     0,   465,   466,     0,     0,     0,     0,     0,     0,
       0,     0,   454,   455,   456,   457,   458,   459,   460,     0,
       0,   467,   468,     0,     0,     0,     0,   461,   469,   462,
     470,     0,     0,   463,   464,   471,     0,   465,   466,   664,
       0,     0,     0,   789,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   472,     0,     0,     0,     0,     0,   469,
       0,   470,     0,   467,   468,     0,   471,     0,     0,   761,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   472,     0,     0,     0,     0,     0,
       0,     0,   467,   468,     0,     0,     0,     0,     0,     0,
       0,   469,     0,   470,     0,     0,     0,     0,   471,     0,
       0,     0,   813,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   472,   467,   468,     0,
     469,     0,   470,     0,     0,     0,     0,   767,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   472,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   469,     0,   470,    -2,   205,
       0,     0,   471,     0,     0,     0,     0,    -8,   -10,   -12,
     -14,   -16,   -18,   -20,   -22,   -24,     0,     0,     0,     0,
     472,     0,     0,     0,     0,     0,     0,     0,     2,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
       0,    14,    15,    16,    17,    18,     0,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,     0,     0,     0,    87,    88,
      89,     0,     0,     0,     0,     0,     0,     0,     1,     0,
       0,     0,     0,     0,     0,     0,    -8,   -10,   -12,   -14,
     -16,   -18,   -20,   -22,   -24,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,     0,
      14,    15,    16,    17,    18,    90,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,     0,     0,     0,    87,    88,    89,
       0,   540,   670,   671,   672,   673,   674,   675,   676,   677,
     541,   542,   543,   544,   545,   546,   547,   548,   549,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    90
};

static const yytype_int16 yycheck[] =
{
     114,   121,   457,   420,   418,   519,   121,   421,   425,   423,
     427,     1,   429,     1,   519,    48,   530,   431,   532,   433,
       1,   568,   535,     1,   519,   530,     1,   532,     1,   576,
       1,   695,   154,   147,   148,   530,     1,   532,     1,     1,
     738,   184,     1,   475,   123,   530,     1,   532,   439,   141,
     142,     1,    21,    22,   149,   487,   152,   179,   490,   491,
     492,     1,     1,     1,   519,     1,   521,   828,     1,   165,
     584,   585,   164,     1,   529,   530,   531,   532,   533,   584,
     585,   176,     1,   519,   539,     1,   123,     1,     1,   584,
     585,     1,     1,   158,   530,   550,   532,   123,     1,   584,
     585,     1,   649,   123,   768,   866,   162,   805,   164,   157,
     158,   502,   157,   158,   550,   529,   181,   123,     1,   880,
       1,     1,     1,     1,     1,   148,   149,   141,   142,   584,
     585,   154,   587,   181,   123,   158,   181,   123,   171,   172,
     173,   162,   165,   164,   141,   142,     1,   180,   584,   585,
     164,   587,   272,   667,   668,     1,   123,   272,   181,   823,
       1,     1,   667,   668,   828,   162,   154,     1,   623,   586,
     148,   149,   667,   668,     1,   630,   154,   632,   168,   157,
     158,   695,   667,   668,   162,   166,   164,   168,   701,   154,
       1,   179,   165,   168,   630,   154,   632,   168,     1,   863,
     864,   865,   866,   181,   166,   168,   168,   157,   872,   873,
     874,   166,   667,   668,   179,   154,   880,   156,   157,   158,
     179,   638,   639,   640,   641,   165,   643,   682,   166,   162,
     166,   667,   668,   665,   167,     1,   691,   165,     1,   148,
     149,   696,   181,     1,   154,   154,   165,   163,   157,   158,
     705,   165,   165,   162,   768,   164,   156,   157,   713,   695,
     163,   693,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   181,   156,   157,   156,   157,   157,   157,   157,
     157,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   838,   706,   707,   437,   727,   728,   729,   730,   442,
     732,   156,   157,   446,   159,   160,   820,   695,     1,   823,
       1,   157,   859,   168,   828,   820,   157,   157,     1,     1,
     695,   148,   149,   157,     1,   820,     1,   154,     1,     1,
     157,   162,   768,   164,     1,   820,   185,   186,     1,     1,
       1,   123,     1,   457,   761,   123,   157,     1,     1,   863,
     864,   865,   866,     1,   157,   498,   811,     9,   872,   873,
     874,   123,   141,   142,     1,   820,   880,     1,     1,     1,
       1,     1,   157,     1,   863,   864,   865,   141,   142,   164,
     768,     1,   814,   815,   820,   164,   803,   823,   154,   156,
     156,   154,   828,   768,     1,     1,   154,     1,   156,   157,
     164,   159,   160,     1,   836,   519,   678,   521,   148,   149,
     168,   525,   179,   123,   154,     1,   530,   154,   532,   156,
     157,   179,   159,   160,   123,   539,     1,   863,   864,   865,
     866,   168,   162,   123,   164,   823,   872,   873,   874,     1,
     828,     1,   179,   157,   880,   162,   123,   164,   823,     1,
     164,   148,   149,   828,     1,   148,   149,   154,     1,   579,
     157,   154,   123,   577,   123,   156,   738,     1,     1,     1,
     584,   585,   154,   156,   156,   863,   864,   865,   866,   154,
     123,   156,   154,   156,   872,   873,   874,   154,   863,   864,
     865,   866,   880,   156,   156,   148,   149,   872,   873,   874,
     154,   154,   123,   123,     1,   880,   154,     1,     1,   623,
       3,     4,     5,     6,     7,     8,     9,   154,     1,     0,
     154,   154,   154,   154,   154,    18,   154,    20,    21,    22,
      23,    24,    25,   805,   654,    28,    29,     1,     1,     1,
       3,     4,     5,     6,     7,     8,     9,   154,   154,    27,
     154,   123,     1,   667,   668,    18,   154,    20,    21,    22,
      23,    24,    25,    11,     1,    28,    29,   681,   154,     1,
       3,     4,     5,     6,     7,     8,     9,   691,     1,   154,
       1,     1,     1,     3,     4,     5,     6,     7,     8,     9,
       1,   705,   154,   123,   154,    28,    29,     1,    18,   713,
      20,   123,   154,    23,    24,    25,   123,   154,    28,    29,
       1,   154,     3,     4,     5,     6,     7,     8,     9,    27,
     154,   154,   154,     1,     1,   118,   119,    18,     1,    20,
       1,     1,    23,    24,    25,   123,     1,    28,    29,     1,
      12,     1,     1,   123,   123,     1,     1,     3,     4,     5,
       6,     7,     8,     9,   157,   118,   119,   154,   123,   123,
     154,   164,    18,   156,    20,   158,    27,   123,    24,    25,
     163,   154,    28,    29,   167,     1,   123,     1,     1,   157,
     158,   159,   160,   161,   157,   118,   119,     1,   181,   162,
     168,   164,   154,   156,   123,   158,     1,   811,   118,   119,
     163,   123,   816,   181,   167,   154,   820,   157,   148,   149,
     150,   151,   123,   123,   164,   148,   149,   154,   181,   123,
     153,   154,   154,   156,   157,   158,   123,   118,   119,    48,
     170,   154,   165,   154,   123,   154,   156,   162,   158,   164,
     148,   149,   123,   163,   123,   123,   154,   167,   181,   157,
     158,     1,    13,     3,     4,     5,     6,     7,     8,     9,
      48,   181,   118,   119,   157,   156,   123,   158,    18,   123,
      20,   164,   163,   181,    24,    25,   167,   154,    28,    29,
     123,   154,   123,   154,   154,   123,   123,   148,   149,   154,
     181,   123,   154,   154,   154,   154,   157,   158,   123,   154,
     156,   154,   158,   156,   157,   123,   123,   163,   123,    10,
       1,   167,     3,     4,     5,     6,     7,     8,     9,   123,
     181,   123,   123,   123,   123,   181,   123,    18,   154,    20,
     154,   154,   123,    24,    25,    14,   123,    28,    29,     1,
     154,     3,     4,     5,     6,     7,     8,     9,   123,   154,
     123,   123,   171,   172,   173,   123,    18,   123,    20,   123,
     123,   180,    24,    25,   123,   123,    28,    29,   118,   119,
       1,   123,     3,     4,     5,     6,     7,     8,     9,   159,
     160,   161,   123,   171,   172,   173,   123,    18,   168,    20,
     123,   123,   180,    24,    25,   123,   123,    28,    29,   148,
     149,   148,   149,   768,   123,   154,   156,   154,   158,   158,
     157,   158,   123,   163,   123,   164,     1,   167,     3,     4,
       5,     6,     7,     8,     9,   123,   123,   118,   119,   123,
     123,   181,   181,    18,   181,    20,   148,   149,   123,    24,
      25,   123,   154,    28,    29,   157,   158,     1,   123,     3,
       4,     5,     6,     7,     8,     9,   118,   119,   823,   123,
      15,    17,   157,    16,    18,   156,    20,   158,   154,   181,
      24,    25,   163,   154,    28,    29,   167,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   154,   118,   119,   154,
     181,   154,     1,   154,   156,   154,   158,   157,   863,   864,
     865,   163,   154,   169,   170,   167,   150,   872,   873,   874,
     156,   154,   156,   157,   154,   159,   160,   156,   157,   181,
     159,   160,   148,   149,   168,   156,   154,   158,   154,   168,
     154,   157,   163,   118,   119,     1,   167,     3,     4,     5,
       6,     7,     8,     9,   178,   178,   178,   159,   178,   178,
     181,   173,    18,   162,    20,   173,   173,   178,    24,    25,
     156,   169,    28,    29,   118,   119,   182,   156,   166,   157,
     156,   156,   154,   158,   165,   156,   163,   169,   163,   169,
     156,   165,   167,   162,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   165,   165,   165,   181,   165,   165,   165,
     165,   165,   156,   165,   158,   164,   169,   154,   169,   163,
     156,   170,     1,   167,     3,     4,     5,     6,     7,     8,
       9,   169,   157,   162,   184,   156,   178,   181,   178,    18,
     164,    20,   164,   178,   157,    24,    25,   157,   166,    28,
      29,     1,    27,     3,     4,     5,     6,     7,     8,     9,
      27,   166,   118,   119,   166,   166,   154,   178,    18,   166,
      20,   165,   154,   164,    24,    25,   162,   164,    28,    29,
     164,   164,     1,   164,     3,     4,     5,     6,     7,     8,
       9,   124,   125,   126,   127,   128,   129,   130,   131,    18,
     156,    20,   158,   162,   164,    24,    25,   163,    26,    28,
      29,   167,   164,   162,   164,   143,   144,   145,   146,   147,
     148,   149,   150,   151,     1,   181,     3,     4,     5,     6,
       7,     8,     9,   169,   164,   164,   162,   151,   157,   118,
     119,    18,   170,    20,   157,   157,   166,    24,    25,   157,
     166,    28,    29,   162,    25,    19,    21,   164,   164,     1,
     164,     3,     4,     5,     6,     7,     8,     9,   118,   119,
     165,   163,   163,   167,   164,   164,    18,   156,    20,   158,
     164,   162,    24,    25,   163,   154,    28,    29,   167,   154,
       3,     4,     5,     6,     7,     8,     9,   183,   162,   118,
     119,   178,   181,   164,   178,    18,   156,    20,   158,   162,
      23,    24,    25,   163,   154,    28,    29,   167,   178,   162,
       3,     4,     5,     6,     7,     8,     9,   157,   154,   183,
      19,   181,   157,   164,   154,    18,   184,   156,   154,   158,
     123,   118,   119,   164,   163,    28,    29,   184,   167,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   151,   154,
      25,   151,   181,     3,     4,     5,     6,     7,     8,     9,
     154,    25,   185,   154,   185,    92,   118,   119,    18,   156,
      20,   158,   119,    23,    24,    25,   163,   272,    28,    29,
     167,   506,   659,   654,   266,   815,   537,   818,    -1,   705,
      -1,    -1,    -1,    -1,   181,   118,   119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   156,    -1,   158,    -1,    -1,    -1,
      -1,   163,    -1,    -1,    -1,   167,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   118,   119,    -1,    -1,   181,
      -1,    -1,    -1,   156,    -1,   158,    -1,    -1,    -1,    -1,
     163,    -1,    -1,   166,    -1,     3,     4,     5,     6,     7,
       8,     9,    -1,    -1,    -1,   148,   149,    -1,   181,   152,
      18,   154,    20,   156,    -1,   158,    24,    25,   118,   119,
      28,    29,   165,   166,    -1,   168,     3,     4,     5,     6,
       7,     8,     9,   587,    -1,    -1,    -1,    -1,   181,    -1,
      -1,    18,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,    28,    29,    -1,    -1,    -1,   156,    -1,   158,    -1,
      -1,    -1,    -1,   163,    -1,    -1,    -1,   167,     3,     4,
       5,     6,     7,     8,     9,    -1,   630,    -1,   632,    -1,
      -1,   181,    -1,    18,    -1,    20,    -1,    -1,    -1,    24,
      25,    -1,    -1,    28,    29,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
     118,   119,    18,    -1,    20,    -1,    -1,    23,    24,    25,
      -1,    -1,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
      -1,   118,   119,    -1,    -1,    -1,    -1,    18,   156,    20,
     158,    -1,    -1,    24,    25,   163,    -1,    28,    29,   167,
      -1,    -1,    -1,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   181,    -1,    -1,    -1,    -1,    -1,   156,
      -1,   158,    -1,   118,   119,    -1,   163,    -1,    -1,   166,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   118,   119,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   156,    -1,   158,    -1,    -1,    -1,    -1,   163,    -1,
      -1,    -1,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   181,   118,   119,    -1,
     156,    -1,   158,    -1,    -1,    -1,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   156,    -1,   158,     0,     1,
      -1,    -1,   163,    -1,    -1,    -1,    -1,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    -1,    -1,    -1,    -1,
     181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,    -1,    -1,    -1,   120,   121,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,   177,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,    -1,    -1,    -1,   120,   121,   122,
      -1,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   177
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    43,    44,    45,    46,    47,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   120,   121,   122,
     177,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   222,   223,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,     1,   123,     1,   123,     1,
     123,     1,   123,     1,   123,     1,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
       1,   157,   123,     1,   165,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,     1,   123,     1,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,     0,     1,   191,     9,   232,    10,
     233,    11,   234,    12,   235,    13,   236,    14,   237,    15,
     238,    16,   239,    17,   240,     1,   154,     1,   154,     1,
     154,     1,   154,     1,   154,     1,   154,     1,   154,     1,
     154,   148,   149,   154,   206,     1,   154,     1,   156,     1,
     157,     1,   154,   156,   204,   207,   208,   214,     1,   214,
     157,     1,   156,   157,   159,   160,   168,   179,   201,   203,
     204,   207,   209,   210,   224,   225,   226,   227,     1,   154,
       1,   154,     1,   154,   154,   154,   154,   154,   154,   154,
       1,   154,     1,   154,     1,   154,     1,   154,     1,   154,
       1,   154,     1,   157,     1,   154,     1,   157,     1,   154,
       1,   206,     1,   206,     1,   154,     1,   154,     1,   154,
       1,   154,     1,   154,     1,   154,     1,   154,     1,   154,
       1,   154,     1,   157,     1,   157,     1,   157,   157,     1,
     154,     1,   156,   157,     1,   156,   157,     1,   154,     1,
     156,   157,     1,   154,     1,   154,     1,   154,     1,   154,
       1,   154,     1,   154,     1,   154,     1,   156,     1,   156,
       1,   154,     1,   154,     1,   154,     1,   154,     1,   154,
       1,   156,   201,     1,   154,     1,   154,     1,   154,     1,
     154,     1,   154,     1,   154,   156,   154,   154,   156,   154,
       1,   157,     1,   157,     1,   154,     1,   154,     1,   156,
     221,     1,   154,   154,     1,   166,   168,     1,   168,     1,
     166,   168,     1,   168,     1,   166,     1,   166,     1,   166,
       1,   168,     1,   168,   154,   154,     1,   178,   216,   215,
     178,   226,   178,   149,   176,   202,   178,   210,   173,   162,
     173,   178,   182,   173,     3,     4,     5,     6,     7,     8,
       9,    18,    20,    24,    25,    28,    29,   118,   119,   156,
     158,   163,   181,   247,   252,   256,   258,   261,   262,   263,
     264,   272,   154,   156,   157,   230,   230,   256,   230,   230,
     256,   256,   256,   230,   230,   150,   201,    48,   171,   172,
     173,   180,   212,   213,   213,     1,   157,   218,   169,   201,
       1,   156,   156,   157,   156,   166,   154,   156,   165,   165,
     165,   165,   206,   247,     1,   165,     1,   165,     1,   165,
     165,   165,   165,   165,   165,   165,   165,   165,     1,   165,
     123,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     250,   163,     1,   167,   258,     1,   163,   169,   169,   167,
     169,   169,   167,   167,   167,   162,   169,   178,   178,   156,
     201,   211,   154,   156,   213,   218,   178,   162,   152,   165,
     219,   220,   184,   164,   152,   165,   166,   168,   206,   241,
     247,   248,   249,   252,   253,   261,   272,   164,   164,   206,
     247,     1,   157,   206,     1,   157,     1,   230,   231,   247,
     241,   247,   241,   247,   157,   229,   157,   229,   156,   271,
     271,     1,   157,   162,   164,   206,   247,   269,    27,    27,
     153,   157,   165,   206,   247,   249,   251,   272,   166,   166,
     166,   166,   154,   166,   154,   179,   205,     1,   205,   178,
       1,   205,   157,   206,   165,   179,   204,   217,     1,   162,
     167,   154,   241,   241,   167,   256,   251,   141,   142,   162,
     124,   125,   126,   127,   128,   129,   130,   131,   242,   243,
     244,   245,   246,   164,   164,   164,   164,   162,   164,   162,
     164,   162,   164,   164,   164,   164,    26,   157,   164,   157,
     164,   162,   164,   164,     1,   165,   162,   162,   164,   164,
     157,   206,   247,   162,   164,   251,   251,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   170,   256,   256,   256,
     256,   169,   256,     1,   205,   164,   164,   217,   162,   219,
     151,   164,   167,   169,   241,   241,   157,    27,   161,   224,
     228,   206,   157,   247,   157,   157,    27,   157,   206,   247,
     270,   166,   255,   258,   166,    18,    23,   163,   166,   252,
     254,   259,   260,   262,   263,   264,   272,   247,   157,   229,
       1,   164,   269,   230,   230,   157,   206,   247,   164,   251,
     251,   251,   251,   251,   251,   251,   251,   251,   251,   167,
     167,   167,   167,   166,   167,   162,   228,    25,   164,   164,
     164,   162,   164,   167,   256,    19,    21,   265,   266,   267,
     165,   163,   167,   257,   259,   163,     1,   163,   164,   164,
     164,   164,   164,   162,   164,   164,   256,   228,   162,   154,
      27,   157,   206,   247,   167,   255,   157,   206,   167,    22,
     267,   268,   241,     1,   167,   259,   254,   154,   167,   162,
     205,   185,   186,   178,   178,   178,   164,   164,   205,   162,
     183,   154,   257,   257,   257,   254,   162,   157,   154,   183,
      19,   157,   164,   184,   154,   254,   164,   154,   184,   151,
     154,    25,   151,   154,    25,   185,   154,   185
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   188,   189,   190,   190,   190,   191,   191,   192,   191,
     193,   191,   194,   191,   195,   191,   196,   191,   197,   191,
     198,   191,   199,   191,   200,   191,   191,   201,   201,   201,
     202,   202,   203,   203,   203,   204,   205,   205,   206,   206,
     206,   207,   207,   207,   207,   208,   208,   209,   209,   209,
     209,   209,   210,   210,   211,   211,   211,   212,   212,   212,
     212,   212,   213,   213,   214,   214,   215,   214,   216,   214,
     217,   217,   218,   218,   219,   219,   220,   220,   220,   221,
     221,   221,   221,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   223,
     223,   223,   223,   223,   224,   224,   225,   226,   227,   227,
     228,   228,   229,   229,   230,   230,   230,   231,   231,   232,
     232,   232,   233,   233,   234,   234,   234,   235,   235,   236,
     236,   237,   237,   238,   238,   239,   239,   240,   240,   241,
     241,   241,   241,   241,   241,   242,   242,   243,   243,   243,
     243,   244,   244,   245,   245,   246,   246,   246,   247,   247,
     248,   248,   248,   248,   249,   249,   249,   249,   249,   250,
     250,   250,   250,   250,   250,   250,   250,   250,   250,   251,
     251,   251,   251,   251,   251,   251,   251,   251,   251,   251,
     251,   251,   251,   251,   251,   251,   252,   252,   252,   253,
     253,   253,   253,   253,   254,   254,   254,   255,   255,   255,
     256,   256,   256,   257,   257,   257,   258,   258,   258,   258,
     258,   258,   258,   258,   259,   259,   259,   259,   259,   259,
     259,   259,   259,   260,   260,   261,   261,   262,   263,   264,
     265,   265,   266,   266,   267,   267,   267,   267,   268,   268,
     269,   269,   269,   269,   269,   269,   269,   269,   269,   269,
     269,   270,   270,   270,   270,   270,   270,   270,   270,   271,
     271,   271,   271,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     1,     2,
       2,     3,     5,     5,     2,     3,     5,     1,     3,     5,
       5,     1,     1,     2,     1,     3,     3,     1,     2,     2,
       2,     2,     1,     2,     1,     1,     0,     3,     0,     3,
       1,     1,     1,     2,     9,    10,     3,     1,     2,    18,
      17,    10,     9,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     3,     3,     3,     3,     5,     3,     3,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     5,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     5,     5,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     2,     7,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       2,     8,     8,     2,     1,     1,     1,     1,     1,     3,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     4,
       7,     2,     7,     2,     4,     7,     2,     7,     2,     4,
       2,     4,     2,     4,     2,     9,     2,     7,     2,     3,
       3,     2,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     3,     3,     1,
       1,     1,     3,     2,     1,     3,     2,     1,     3,     2,
       2,     1,     2,     2,     1,     2,     2,     1,     1,     1,
       1,     2,     1,     2,     2,     2,     1,     1,     1,     1,
       2,     1,     2,     5,     7,     5,     7,     5,     7,     7,
       2,     1,     2,     1,     4,     3,     4,     3,     3,     2,
       1,     3,     1,     2,     2,     1,     2,     3,     1,     2,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       4,     4,     2,     6,     1,     3,     1,     3,     2,     4,
       2,     4,     3,     1,     4,     6,     2,     4,     6,     2,
       4,     4,     6,     2,     4,     3,     4,     4,     2,     4,
       4,     4,     4,     6,     6,     6,     8,     6,     4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* statements: statements statement  */
#line 482 "cfg.y"
                                     {}
#line 2381 "cfg.tab.c"
    break;

  case 4: /* statements: statement  */
#line 483 "cfg.y"
                            {}
#line 2387 "cfg.tab.c"
    break;

  case 5: /* statements: statements error  */
#line 484 "cfg.y"
                                   { yyerror(""); YYABORT;}
#line 2393 "cfg.tab.c"
    break;

  case 8: /* $@1: %empty  */
#line 489 "cfg.y"
                  {rt=REQUEST_ROUTE;}
#line 2399 "cfg.tab.c"
    break;

  case 10: /* $@2: %empty  */
#line 490 "cfg.y"
                  {rt=FAILURE_ROUTE;}
#line 2405 "cfg.tab.c"
    break;

  case 12: /* $@3: %empty  */
#line 491 "cfg.y"
                  {rt=ONREPLY_ROUTE;}
#line 2411 "cfg.tab.c"
    break;

  case 14: /* $@4: %empty  */
#line 492 "cfg.y"
                  {rt=BRANCH_ROUTE;}
#line 2417 "cfg.tab.c"
    break;

  case 16: /* $@5: %empty  */
#line 493 "cfg.y"
                  {rt=ERROR_ROUTE;}
#line 2423 "cfg.tab.c"
    break;

  case 18: /* $@6: %empty  */
#line 494 "cfg.y"
                  {rt=LOCAL_ROUTE;}
#line 2429 "cfg.tab.c"
    break;

  case 20: /* $@7: %empty  */
#line 495 "cfg.y"
                  {rt=STARTUP_ROUTE;}
#line 2435 "cfg.tab.c"
    break;

  case 22: /* $@8: %empty  */
#line 496 "cfg.y"
                  {rt=TIMER_ROUTE;}
#line 2441 "cfg.tab.c"
    break;

  case 24: /* $@9: %empty  */
#line 497 "cfg.y"
                  {rt=EVENT_ROUTE;}
#line 2447 "cfg.tab.c"
    break;

  case 27: /* listen_id: ip  */
#line 502 "cfg.y"
                                        { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2467 "cfg.tab.c"
    break;

  case 28: /* listen_id: STRING  */
#line 517 "cfg.y"
                                        { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2481 "cfg.tab.c"
    break;

  case 29: /* listen_id: host  */
#line 526 "cfg.y"
                                        { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2499 "cfg.tab.c"
    break;

  case 30: /* host_sep: DOT  */
#line 541 "cfg.y"
                    {(yyval.strval)=".";}
#line 2505 "cfg.tab.c"
    break;

  case 31: /* host_sep: MINUS  */
#line 542 "cfg.y"
                              {(yyval.strval)="-"; }
#line 2511 "cfg.tab.c"
    break;

  case 32: /* host: ID  */
#line 545 "cfg.y"
                                        { (yyval.strval)=(yyvsp[0].strval); }
#line 2517 "cfg.tab.c"
    break;

  case 33: /* host: host host_sep ID  */
#line 546 "cfg.y"
                                { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2536 "cfg.tab.c"
    break;

  case 34: /* host: host DOT error  */
#line 560 "cfg.y"
                         { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2544 "cfg.tab.c"
    break;

  case 35: /* proto: ID  */
#line 565 "cfg.y"
           { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2557 "cfg.tab.c"
    break;

  case 36: /* port: NUMBER  */
#line 575 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 2563 "cfg.tab.c"
    break;

  case 37: /* port: ANY  */
#line 576 "cfg.y"
                                { (yyval.intval)=0; }
#line 2569 "cfg.tab.c"
    break;

  case 38: /* snumber: NUMBER  */
#line 579 "cfg.y"
                        { (yyval.intval)=(yyvsp[0].intval); }
#line 2575 "cfg.tab.c"
    break;

  case 39: /* snumber: PLUS NUMBER  */
#line 580 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 2581 "cfg.tab.c"
    break;

  case 40: /* snumber: MINUS NUMBER  */
#line 581 "cfg.y"
                                { (yyval.intval)=-(yyvsp[0].intval); }
#line 2587 "cfg.tab.c"
    break;

  case 41: /* phostport: proto COLON listen_id  */
#line 585 "cfg.y"
                                        { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2594 "cfg.tab.c"
    break;

  case 42: /* phostport: proto COLON listen_id COLON port  */
#line 587 "cfg.y"
                                                                { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2601 "cfg.tab.c"
    break;

  case 43: /* phostport: proto COLON listen_id COLON error  */
#line 589 "cfg.y"
                                                            {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2611 "cfg.tab.c"
    break;

  case 44: /* phostport: NUMBER error  */
#line 594 "cfg.y"
                                       { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2620 "cfg.tab.c"
    break;

  case 45: /* panyhostport: proto COLON MULT  */
#line 600 "cfg.y"
                                                        { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2627 "cfg.tab.c"
    break;

  case 46: /* panyhostport: proto COLON MULT COLON port  */
#line 602 "cfg.y"
                                                        { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-4].intval), (yyvsp[0].intval)); }
#line 2634 "cfg.tab.c"
    break;

  case 47: /* alias_def: listen_id  */
#line 606 "cfg.y"
                                                                        { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2641 "cfg.tab.c"
    break;

  case 48: /* alias_def: ANY COLON listen_id  */
#line 608 "cfg.y"
                                                                        { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2648 "cfg.tab.c"
    break;

  case 49: /* alias_def: ANY COLON listen_id COLON port  */
#line 610 "cfg.y"
                                                        { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2655 "cfg.tab.c"
    break;

  case 50: /* alias_def: ANY COLON listen_id COLON error  */
#line 612 "cfg.y"
                                                        {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2664 "cfg.tab.c"
    break;

  case 52: /* id_lst: alias_def  */
#line 619 "cfg.y"
                                        { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2670 "cfg.tab.c"
    break;

  case 53: /* id_lst: alias_def id_lst  */
#line 620 "cfg.y"
                                        { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2676 "cfg.tab.c"
    break;

  case 54: /* listen_id_def: listen_id  */
#line 623 "cfg.y"
                                                                { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2683 "cfg.tab.c"
    break;

  case 55: /* listen_id_def: listen_id COLON port  */
#line 625 "cfg.y"
                                                                { IFOR();
			 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2690 "cfg.tab.c"
    break;

  case 56: /* listen_id_def: listen_id COLON error  */
#line 627 "cfg.y"
                                                      {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2699 "cfg.tab.c"
    break;

  case 57: /* socket_def_param: ANYCAST  */
#line 633 "cfg.y"
                          { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 2707 "cfg.tab.c"
    break;

  case 58: /* socket_def_param: USE_WORKERS NUMBER  */
#line 636 "cfg.y"
                                                     { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 2715 "cfg.tab.c"
    break;

  case 59: /* socket_def_param: AS listen_id_def  */
#line 639 "cfg.y"
                                                   { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 2723 "cfg.tab.c"
    break;

  case 60: /* socket_def_param: TAG ID  */
#line 642 "cfg.y"
                                         { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 2731 "cfg.tab.c"
    break;

  case 61: /* socket_def_param: USE_AUTO_SCALING_PROFILE ID  */
#line 645 "cfg.y"
                                                              { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 2739 "cfg.tab.c"
    break;

  case 64: /* socket_def: panyhostport  */
#line 654 "cfg.y"
                                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2745 "cfg.tab.c"
    break;

  case 65: /* socket_def: phostport  */
#line 655 "cfg.y"
                                                                { (yyval.sockid)=(yyvsp[0].sockid); }
#line 2751 "cfg.tab.c"
    break;

  case 66: /* $@10: %empty  */
#line 656 "cfg.y"
                                       { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2759 "cfg.tab.c"
    break;

  case 67: /* socket_def: panyhostport $@10 socket_def_params  */
#line 658 "cfg.y"
                                                        { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2767 "cfg.tab.c"
    break;

  case 68: /* $@11: %empty  */
#line 661 "cfg.y"
                                    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 2775 "cfg.tab.c"
    break;

  case 69: /* socket_def: phostport $@11 socket_def_params  */
#line 663 "cfg.y"
                                                        { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 2783 "cfg.tab.c"
    break;

  case 70: /* any_proto: ANY  */
#line 668 "cfg.y"
                        { (yyval.intval)=PROTO_NONE; }
#line 2789 "cfg.tab.c"
    break;

  case 71: /* any_proto: proto  */
#line 669 "cfg.y"
                                { (yyval.intval)=(yyvsp[0].intval); }
#line 2795 "cfg.tab.c"
    break;

  case 72: /* multi_string: STRING  */
#line 671 "cfg.y"
                       {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 2801 "cfg.tab.c"
    break;

  case 73: /* multi_string: STRING multi_string  */
#line 672 "cfg.y"
                                      { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 2807 "cfg.tab.c"
    break;

  case 74: /* blst_elem: LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 675 "cfg.y"
                                                                        {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2820 "cfg.tab.c"
    break;

  case 75: /* blst_elem: NOT LPAREN any_proto COMMA ipnet COMMA port COMMA STRING RPAREN  */
#line 683 "cfg.y"
                                                                                    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 2834 "cfg.tab.c"
    break;

  case 76: /* blst_elem_list: blst_elem_list COMMA blst_elem  */
#line 694 "cfg.y"
                                               {}
#line 2840 "cfg.tab.c"
    break;

  case 77: /* blst_elem_list: blst_elem  */
#line 695 "cfg.y"
                            {}
#line 2846 "cfg.tab.c"
    break;

  case 78: /* blst_elem_list: blst_elem_list error  */
#line 696 "cfg.y"
                                       { yyerror("bad black list element");}
#line 2852 "cfg.tab.c"
    break;

  case 79: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES_WITHIN NUMBER SCALE_DOWN_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 703 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 2862 "cfg.tab.c"
    break;

  case 80: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES SCALE_DOWN_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 711 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 2872 "cfg.tab.c"
    break;

  case 81: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES_WITHIN NUMBER  */
#line 717 "cfg.y"
                                                            { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 2882 "cfg.tab.c"
    break;

  case 82: /* auto_scale_profile_def: ID SCALE_UP_TO NUMBER ON NUMBER MODULO FOR NUMBER CYCLES  */
#line 723 "cfg.y"
                                              { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 2892 "cfg.tab.c"
    break;

  case 83: /* assign_stm: LOGLEVEL EQUAL snumber  */
#line 730 "cfg.y"
                                   { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 2901 "cfg.tab.c"
    break;

  case 84: /* assign_stm: ENABLE_ASSERTS EQUAL NUMBER  */
#line 734 "cfg.y"
                                               { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 2907 "cfg.tab.c"
    break;

  case 85: /* assign_stm: ENABLE_ASSERTS EQUAL error  */
#line 735 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 2913 "cfg.tab.c"
    break;

  case 86: /* assign_stm: ABORT_ON_ASSERT EQUAL NUMBER  */
#line 736 "cfg.y"
                                                { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 2919 "cfg.tab.c"
    break;

  case 87: /* assign_stm: ABORT_ON_ASSERT EQUAL error  */
#line 737 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 2925 "cfg.tab.c"
    break;

  case 88: /* assign_stm: DEBUG_MODE EQUAL NUMBER  */
#line 738 "cfg.y"
                                           { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) { *log_level = L_DBG;log_stderr=1;}
			}
#line 2934 "cfg.tab.c"
    break;

  case 89: /* assign_stm: DEBUG_MODE EQUAL error  */
#line 743 "cfg.y"
                        { yyerror("boolean value expected for debug_mode"); }
#line 2940 "cfg.tab.c"
    break;

  case 90: /* assign_stm: LOGSTDERROR EQUAL NUMBER  */
#line 747 "cfg.y"
                        { IFOR(); if (!config_check && !debug_mode) log_stderr=(yyvsp[0].intval); }
#line 2946 "cfg.tab.c"
    break;

  case 91: /* assign_stm: LOGSTDERROR EQUAL error  */
#line 748 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 2952 "cfg.tab.c"
    break;

  case 92: /* assign_stm: LOGFACILITY EQUAL ID  */
#line 749 "cfg.y"
                                       { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 2963 "cfg.tab.c"
    break;

  case 93: /* assign_stm: LOGFACILITY EQUAL error  */
#line 755 "cfg.y"
                                          { yyerror("ID expected"); }
#line 2969 "cfg.tab.c"
    break;

  case 94: /* assign_stm: LOGNAME EQUAL STRING  */
#line 756 "cfg.y"
                                       { IFOR(); log_name=(yyvsp[0].strval); }
#line 2975 "cfg.tab.c"
    break;

  case 95: /* assign_stm: LOGNAME EQUAL error  */
#line 757 "cfg.y"
                                      { yyerror("string value expected"); }
#line 2981 "cfg.tab.c"
    break;

  case 96: /* assign_stm: DNS EQUAL NUMBER  */
#line 758 "cfg.y"
                                     { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 2987 "cfg.tab.c"
    break;

  case 97: /* assign_stm: DNS EQUAL error  */
#line 759 "cfg.y"
                                  { yyerror("boolean value expected"); }
#line 2993 "cfg.tab.c"
    break;

  case 98: /* assign_stm: REV_DNS EQUAL NUMBER  */
#line 760 "cfg.y"
                                       { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 2999 "cfg.tab.c"
    break;

  case 99: /* assign_stm: REV_DNS EQUAL error  */
#line 761 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3005 "cfg.tab.c"
    break;

  case 100: /* assign_stm: DNS_TRY_IPV6 EQUAL NUMBER  */
#line 762 "cfg.y"
                                              { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3011 "cfg.tab.c"
    break;

  case 101: /* assign_stm: DNS_TRY_IPV6 error  */
#line 763 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 3017 "cfg.tab.c"
    break;

  case 102: /* assign_stm: DNS_TRY_NAPTR EQUAL NUMBER  */
#line 764 "cfg.y"
                                               { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3023 "cfg.tab.c"
    break;

  case 103: /* assign_stm: DNS_TRY_NAPTR error  */
#line 765 "cfg.y"
                                      { yyerror("boolean value expected"); }
#line 3029 "cfg.tab.c"
    break;

  case 104: /* assign_stm: DNS_RETR_TIME EQUAL NUMBER  */
#line 766 "cfg.y"
                                               { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3035 "cfg.tab.c"
    break;

  case 105: /* assign_stm: DNS_RETR_TIME error  */
#line 767 "cfg.y"
                                      { yyerror("number expected"); }
#line 3041 "cfg.tab.c"
    break;

  case 106: /* assign_stm: DNS_RETR_NO EQUAL NUMBER  */
#line 768 "cfg.y"
                                             { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3047 "cfg.tab.c"
    break;

  case 107: /* assign_stm: DNS_RETR_NO error  */
#line 769 "cfg.y"
                                    { yyerror("number expected"); }
#line 3053 "cfg.tab.c"
    break;

  case 108: /* assign_stm: DNS_SERVERS_NO EQUAL NUMBER  */
#line 770 "cfg.y"
                                                { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3059 "cfg.tab.c"
    break;

  case 109: /* assign_stm: DNS_SERVERS_NO error  */
#line 771 "cfg.y"
                                       { yyerror("number expected"); }
#line 3065 "cfg.tab.c"
    break;

  case 110: /* assign_stm: DNS_USE_SEARCH EQUAL NUMBER  */
#line 772 "cfg.y"
                                                { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3071 "cfg.tab.c"
    break;

  case 111: /* assign_stm: DNS_USE_SEARCH error  */
#line 773 "cfg.y"
                                       { yyerror("boolean value expected"); }
#line 3077 "cfg.tab.c"
    break;

  case 112: /* assign_stm: MAX_WHILE_LOOPS EQUAL NUMBER  */
#line 774 "cfg.y"
                                               { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3083 "cfg.tab.c"
    break;

  case 113: /* assign_stm: MAX_WHILE_LOOPS EQUAL error  */
#line 775 "cfg.y"
                                              { yyerror("number expected"); }
#line 3089 "cfg.tab.c"
    break;

  case 114: /* assign_stm: MAXBUFFER EQUAL NUMBER  */
#line 776 "cfg.y"
                                         { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3095 "cfg.tab.c"
    break;

  case 115: /* assign_stm: MAXBUFFER EQUAL error  */
#line 777 "cfg.y"
                                        { yyerror("number expected"); }
#line 3101 "cfg.tab.c"
    break;

  case 116: /* assign_stm: UDP_WORKERS EQUAL NUMBER  */
#line 778 "cfg.y"
                                           { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3107 "cfg.tab.c"
    break;

  case 117: /* assign_stm: UDP_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 779 "cfg.y"
                                                                       { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3116 "cfg.tab.c"
    break;

  case 118: /* assign_stm: UDP_WORKERS EQUAL error  */
#line 783 "cfg.y"
                                          { yyerror("number expected"); }
#line 3122 "cfg.tab.c"
    break;

  case 119: /* assign_stm: TIMER_WORKERS EQUAL NUMBER  */
#line 784 "cfg.y"
                                             { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3130 "cfg.tab.c"
    break;

  case 120: /* assign_stm: TIMER_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 787 "cfg.y"
                                                                         { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3139 "cfg.tab.c"
    break;

  case 121: /* assign_stm: CHECK_VIA EQUAL NUMBER  */
#line 791 "cfg.y"
                                         { check_via=(yyvsp[0].intval); }
#line 3145 "cfg.tab.c"
    break;

  case 122: /* assign_stm: CHECK_VIA EQUAL error  */
#line 792 "cfg.y"
                                        { yyerror("boolean value expected"); }
#line 3151 "cfg.tab.c"
    break;

  case 123: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL NUMBER  */
#line 793 "cfg.y"
                                                         { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3164 "cfg.tab.c"
    break;

  case 124: /* assign_stm: SHM_HASH_SPLIT_PERCENTAGE EQUAL error  */
#line 801 "cfg.y"
                                                        {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3177 "cfg.tab.c"
    break;

  case 125: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL NUMBER  */
#line 809 "cfg.y"
                                                       { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3190 "cfg.tab.c"
    break;

  case 126: /* assign_stm: SHM_SECONDARY_HASH_SIZE EQUAL error  */
#line 817 "cfg.y"
                                                      {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3203 "cfg.tab.c"
    break;

  case 127: /* assign_stm: MEM_WARMING_ENABLED EQUAL NUMBER  */
#line 825 "cfg.y"
                                                   { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3216 "cfg.tab.c"
    break;

  case 128: /* assign_stm: MEM_WARMING_ENABLED EQUAL error  */
#line 833 "cfg.y"
                                                  {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3229 "cfg.tab.c"
    break;

  case 129: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL STRING  */
#line 841 "cfg.y"
                                                        { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3242 "cfg.tab.c"
    break;

  case 130: /* assign_stm: MEM_WARMING_PATTERN_FILE EQUAL error  */
#line 849 "cfg.y"
                                                       {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3255 "cfg.tab.c"
    break;

  case 131: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL NUMBER  */
#line 857 "cfg.y"
                                                      { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3268 "cfg.tab.c"
    break;

  case 132: /* assign_stm: MEM_WARMING_PERCENTAGE EQUAL error  */
#line 865 "cfg.y"
                                                     {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3281 "cfg.tab.c"
    break;

  case 133: /* assign_stm: RPM_MEM_FILE EQUAL STRING  */
#line 873 "cfg.y"
                                            { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 3289 "cfg.tab.c"
    break;

  case 134: /* assign_stm: RPM_MEM_FILE EQUAL error  */
#line 876 "cfg.y"
                                           { yyerror("string value expected"); }
#line 3295 "cfg.tab.c"
    break;

  case 135: /* assign_stm: RPM_MEM_SIZE EQUAL NUMBER  */
#line 877 "cfg.y"
                                            { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 3303 "cfg.tab.c"
    break;

  case 136: /* assign_stm: RPM_MEM_SIZE EQUAL error  */
#line 880 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3309 "cfg.tab.c"
    break;

  case 137: /* assign_stm: MEMLOG EQUAL snumber  */
#line 881 "cfg.y"
                                       { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 3315 "cfg.tab.c"
    break;

  case 138: /* assign_stm: MEMLOG EQUAL error  */
#line 882 "cfg.y"
                                     { yyerror("int value expected"); }
#line 3321 "cfg.tab.c"
    break;

  case 139: /* assign_stm: MEMDUMP EQUAL snumber  */
#line 883 "cfg.y"
                                        { IFOR(); memdump=(yyvsp[0].intval); }
#line 3327 "cfg.tab.c"
    break;

  case 140: /* assign_stm: MEMDUMP EQUAL error  */
#line 884 "cfg.y"
                                      { yyerror("int value expected"); }
#line 3333 "cfg.tab.c"
    break;

  case 141: /* assign_stm: EXECMSGTHRESHOLD EQUAL NUMBER  */
#line 885 "cfg.y"
                                                {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 3339 "cfg.tab.c"
    break;

  case 142: /* assign_stm: EXECMSGTHRESHOLD EQUAL error  */
#line 886 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3345 "cfg.tab.c"
    break;

  case 143: /* assign_stm: EXECDNSTHRESHOLD EQUAL NUMBER  */
#line 887 "cfg.y"
                                                { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 3351 "cfg.tab.c"
    break;

  case 144: /* assign_stm: EXECDNSTHRESHOLD EQUAL error  */
#line 888 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3357 "cfg.tab.c"
    break;

  case 145: /* assign_stm: TCPTHRESHOLD EQUAL NUMBER  */
#line 889 "cfg.y"
                                            { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 3363 "cfg.tab.c"
    break;

  case 146: /* assign_stm: TCPTHRESHOLD EQUAL error  */
#line 890 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3369 "cfg.tab.c"
    break;

  case 147: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL NUMBER  */
#line 891 "cfg.y"
                                                   { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 3384 "cfg.tab.c"
    break;

  case 148: /* assign_stm: EVENT_SHM_THRESHOLD EQUAL error  */
#line 901 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 3390 "cfg.tab.c"
    break;

  case 149: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL NUMBER  */
#line 902 "cfg.y"
                                                   { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 3409 "cfg.tab.c"
    break;

  case 150: /* assign_stm: EVENT_PKG_THRESHOLD EQUAL error  */
#line 916 "cfg.y"
                                                  { yyerror("int value expected"); }
#line 3415 "cfg.tab.c"
    break;

  case 151: /* assign_stm: QUERYBUFFERSIZE EQUAL NUMBER  */
#line 917 "cfg.y"
                                               { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 3421 "cfg.tab.c"
    break;

  case 152: /* assign_stm: QUERYBUFFERSIZE EQUAL error  */
#line 918 "cfg.y"
                                              { yyerror("int value expected"); }
#line 3427 "cfg.tab.c"
    break;

  case 153: /* assign_stm: QUERYFLUSHTIME EQUAL NUMBER  */
#line 919 "cfg.y"
                                              { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 3433 "cfg.tab.c"
    break;

  case 154: /* assign_stm: QUERYFLUSHTIME EQUAL error  */
#line 920 "cfg.y"
                                             { yyerror("int value expected"); }
#line 3439 "cfg.tab.c"
    break;

  case 155: /* assign_stm: SIP_WARNING EQUAL NUMBER  */
#line 921 "cfg.y"
                                           { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 3445 "cfg.tab.c"
    break;

  case 156: /* assign_stm: SIP_WARNING EQUAL error  */
#line 922 "cfg.y"
                                          { yyerror("boolean value expected"); }
#line 3451 "cfg.tab.c"
    break;

  case 157: /* assign_stm: CHROOT EQUAL STRING  */
#line 923 "cfg.y"
                                          { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3457 "cfg.tab.c"
    break;

  case 158: /* assign_stm: CHROOT EQUAL ID  */
#line 924 "cfg.y"
                                          { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 3463 "cfg.tab.c"
    break;

  case 159: /* assign_stm: CHROOT EQUAL error  */
#line 925 "cfg.y"
                                          { yyerror("string value expected"); }
#line 3469 "cfg.tab.c"
    break;

  case 160: /* assign_stm: WDIR EQUAL STRING  */
#line 926 "cfg.y"
                                        { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3475 "cfg.tab.c"
    break;

  case 161: /* assign_stm: WDIR EQUAL ID  */
#line 927 "cfg.y"
                                        { IFOR(); working_dir=(yyvsp[0].strval); }
#line 3481 "cfg.tab.c"
    break;

  case 162: /* assign_stm: WDIR EQUAL error  */
#line 928 "cfg.y"
                                        { yyerror("string value expected"); }
#line 3487 "cfg.tab.c"
    break;

  case 163: /* assign_stm: MHOMED EQUAL NUMBER  */
#line 929 "cfg.y"
                                      { IFOR(); mhomed=(yyvsp[0].intval); }
#line 3493 "cfg.tab.c"
    break;

  case 164: /* assign_stm: MHOMED EQUAL error  */
#line 930 "cfg.y"
                                     { yyerror("boolean value expected"); }
#line 3499 "cfg.tab.c"
    break;

  case 165: /* assign_stm: POLL_METHOD EQUAL ID  */
#line 931 "cfg.y"
                                       { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 3514 "cfg.tab.c"
    break;

  case 166: /* assign_stm: POLL_METHOD EQUAL STRING  */
#line 941 "cfg.y"
                                           { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 3529 "cfg.tab.c"
    break;

  case 167: /* assign_stm: POLL_METHOD EQUAL error  */
#line 951 "cfg.y"
                                          { yyerror("poll method name expected"); }
#line 3535 "cfg.tab.c"
    break;

  case 168: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL NUMBER  */
#line 952 "cfg.y"
                                                  { IFOR();
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 3543 "cfg.tab.c"
    break;

  case 169: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL error  */
#line 955 "cfg.y"
                                                 { yyerror("boolean value expected"); }
#line 3549 "cfg.tab.c"
    break;

  case 170: /* assign_stm: TCP_WORKERS EQUAL NUMBER  */
#line 956 "cfg.y"
                                           { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 3557 "cfg.tab.c"
    break;

  case 171: /* assign_stm: TCP_WORKERS EQUAL NUMBER USE_AUTO_SCALING_PROFILE ID  */
#line 959 "cfg.y"
                                                                      { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3566 "cfg.tab.c"
    break;

  case 172: /* assign_stm: TCP_WORKERS EQUAL error  */
#line 963 "cfg.y"
                                          { yyerror("number expected"); }
#line 3572 "cfg.tab.c"
    break;

  case 173: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL NUMBER  */
#line 964 "cfg.y"
                                                   { IFOR();
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 3580 "cfg.tab.c"
    break;

  case 174: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL error  */
#line 967 "cfg.y"
                                                  { yyerror("number expected"); }
#line 3586 "cfg.tab.c"
    break;

  case 175: /* assign_stm: TCP_CON_LIFETIME EQUAL NUMBER  */
#line 968 "cfg.y"
                                                { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 3594 "cfg.tab.c"
    break;

  case 176: /* assign_stm: TCP_CON_LIFETIME EQUAL error  */
#line 971 "cfg.y"
                                               { yyerror("number expected"); }
#line 3600 "cfg.tab.c"
    break;

  case 177: /* assign_stm: TCP_LISTEN_BACKLOG EQUAL NUMBER  */
#line 972 "cfg.y"
                                                  { IFOR();
				warn("tcp_listen_backlog is deprecated, use tcp_socket_backlog");
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 3609 "cfg.tab.c"
    break;

  case 178: /* assign_stm: TCP_LISTEN_BACKLOG EQUAL error  */
#line 976 "cfg.y"
                                                 { yyerror("number expected"); }
#line 3615 "cfg.tab.c"
    break;

  case 179: /* assign_stm: TCP_SOCKET_BACKLOG EQUAL NUMBER  */
#line 977 "cfg.y"
                                                  { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 3623 "cfg.tab.c"
    break;

  case 180: /* assign_stm: TCP_SOCKET_BACKLOG EQUAL error  */
#line 980 "cfg.y"
                                                 { yyerror("number expected"); }
#line 3629 "cfg.tab.c"
    break;

  case 181: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL NUMBER  */
#line 981 "cfg.y"
                                                   { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 3637 "cfg.tab.c"
    break;

  case 182: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL error  */
#line 984 "cfg.y"
                                                  { yyerror("number expected"); }
#line 3643 "cfg.tab.c"
    break;

  case 183: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL ID  */
#line 985 "cfg.y"
                                                 { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 3655 "cfg.tab.c"
    break;

  case 184: /* assign_stm: TCP_NO_NEW_CONN_BFLAG EQUAL error  */
#line 992 "cfg.y"
                                                    { yyerror("number value expected"); }
#line 3661 "cfg.tab.c"
    break;

  case 185: /* assign_stm: TCP_NO_NEW_CONN_RPLFLAG EQUAL ID  */
#line 993 "cfg.y"
                                                   { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 3673 "cfg.tab.c"
    break;

  case 186: /* assign_stm: TCP_NO_NEW_CONN_RPLFLAG EQUAL error  */
#line 1000 "cfg.y"
                                                      { yyerror("number value expected"); }
#line 3679 "cfg.tab.c"
    break;

  case 187: /* assign_stm: TCP_KEEPALIVE EQUAL NUMBER  */
#line 1002 "cfg.y"
                                             { IFOR();
				tcp_keepalive=(yyvsp[0].intval);
		}
#line 3687 "cfg.tab.c"
    break;

  case 188: /* assign_stm: TCP_KEEPALIVE EQUAL error  */
#line 1005 "cfg.y"
                                            { yyerror("boolean value expected"); }
#line 3693 "cfg.tab.c"
    break;

  case 189: /* assign_stm: TCP_MAX_MSG_TIME EQUAL NUMBER  */
#line 1006 "cfg.y"
                                                { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 3701 "cfg.tab.c"
    break;

  case 190: /* assign_stm: TCP_MAX_MSG_TIME EQUAL error  */
#line 1009 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3707 "cfg.tab.c"
    break;

  case 191: /* assign_stm: TCP_KEEPCOUNT EQUAL NUMBER  */
#line 1010 "cfg.y"
                                                        { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 3719 "cfg.tab.c"
    break;

  case 192: /* assign_stm: TCP_KEEPCOUNT EQUAL error  */
#line 1017 "cfg.y"
                                            { yyerror("int value expected"); }
#line 3725 "cfg.tab.c"
    break;

  case 193: /* assign_stm: TCP_KEEPIDLE EQUAL NUMBER  */
#line 1018 "cfg.y"
                                                        { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 3737 "cfg.tab.c"
    break;

  case 194: /* assign_stm: TCP_KEEPIDLE EQUAL error  */
#line 1025 "cfg.y"
                                           { yyerror("int value expected"); }
#line 3743 "cfg.tab.c"
    break;

  case 195: /* assign_stm: TCP_KEEPINTERVAL EQUAL NUMBER  */
#line 1026 "cfg.y"
                                                { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 3755 "cfg.tab.c"
    break;

  case 196: /* assign_stm: TCP_KEEPINTERVAL EQUAL error  */
#line 1033 "cfg.y"
                                               { yyerror("int value expected"); }
#line 3761 "cfg.tab.c"
    break;

  case 197: /* assign_stm: SERVER_SIGNATURE EQUAL NUMBER  */
#line 1034 "cfg.y"
                                                { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 3768 "cfg.tab.c"
    break;

  case 198: /* assign_stm: SERVER_SIGNATURE EQUAL error  */
#line 1036 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3774 "cfg.tab.c"
    break;

  case 199: /* assign_stm: SERVER_HEADER EQUAL STRING  */
#line 1037 "cfg.y"
                                             { IFOR();
							server_header.s=(yyvsp[0].strval);
							server_header.len=strlen((yyvsp[0].strval));
							}
#line 3783 "cfg.tab.c"
    break;

  case 200: /* assign_stm: SERVER_HEADER EQUAL error  */
#line 1041 "cfg.y"
                                            { yyerror("string value expected"); }
#line 3789 "cfg.tab.c"
    break;

  case 201: /* assign_stm: USER_AGENT_HEADER EQUAL STRING  */
#line 1042 "cfg.y"
                                                 { user_agent_header.s=(yyvsp[0].strval);
									user_agent_header.len=strlen((yyvsp[0].strval));
									}
#line 3797 "cfg.tab.c"
    break;

  case 202: /* assign_stm: USER_AGENT_HEADER EQUAL error  */
#line 1045 "cfg.y"
                                                { yyerror("string value expected"); }
#line 3803 "cfg.tab.c"
    break;

  case 203: /* assign_stm: PV_PRINT_BUF_SIZE EQUAL NUMBER  */
#line 1046 "cfg.y"
                                                 { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 3810 "cfg.tab.c"
    break;

  case 204: /* assign_stm: PV_PRINT_BUF_SIZE EQUAL error  */
#line 1048 "cfg.y"
                                                { yyerror("number expected"); }
#line 3816 "cfg.tab.c"
    break;

  case 205: /* assign_stm: XLOG_BUF_SIZE EQUAL NUMBER  */
#line 1049 "cfg.y"
                                             { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 3823 "cfg.tab.c"
    break;

  case 206: /* assign_stm: XLOG_FORCE_COLOR EQUAL NUMBER  */
#line 1051 "cfg.y"
                                                { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 3830 "cfg.tab.c"
    break;

  case 207: /* assign_stm: XLOG_PRINT_LEVEL EQUAL NUMBER  */
#line 1053 "cfg.y"
                                                { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 3837 "cfg.tab.c"
    break;

  case 208: /* assign_stm: XLOG_BUF_SIZE EQUAL error  */
#line 1055 "cfg.y"
                                            { yyerror("number expected"); }
#line 3843 "cfg.tab.c"
    break;

  case 209: /* assign_stm: XLOG_FORCE_COLOR EQUAL error  */
#line 1056 "cfg.y"
                                               { yyerror("boolean value expected"); }
#line 3849 "cfg.tab.c"
    break;

  case 210: /* assign_stm: XLOG_PRINT_LEVEL EQUAL error  */
#line 1057 "cfg.y"
                                               { yyerror("number expected"); }
#line 3855 "cfg.tab.c"
    break;

  case 211: /* assign_stm: XLOG_LEVEL EQUAL NUMBER  */
#line 1058 "cfg.y"
                                          { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 3862 "cfg.tab.c"
    break;

  case 212: /* assign_stm: XLOG_LEVEL EQUAL error  */
#line 1060 "cfg.y"
                                         { yyerror("number expected"); }
#line 3868 "cfg.tab.c"
    break;

  case 213: /* assign_stm: SOCKET EQUAL socket_def  */
#line 1061 "cfg.y"
                                          { IFOR();
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listening socket\n");
								break;
							}
						}
#line 3880 "cfg.tab.c"
    break;

  case 214: /* assign_stm: SOCKET EQUAL error  */
#line 1068 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 3888 "cfg.tab.c"
    break;

  case 215: /* assign_stm: LISTEN EQUAL socket_def  */
#line 1071 "cfg.y"
                                          { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							if (add_listening_socket((yyvsp[0].sockid))!=0){
								LM_CRIT("cfg. parser: failed"
										" to add listen address\n");
								break;
							}
						}
#line 3901 "cfg.tab.c"
    break;

  case 216: /* assign_stm: LISTEN EQUAL error  */
#line 1079 "cfg.y"
                                      { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 3909 "cfg.tab.c"
    break;

  case 217: /* assign_stm: MEMGROUP EQUAL STRING COLON multi_string  */
#line 1082 "cfg.y"
                                                           { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;	

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 3958 "cfg.tab.c"
    break;

  case 218: /* assign_stm: MEMGROUP EQUAL STRING COLON error  */
#line 1126 "cfg.y"
                                                    { yyerror("invalid or no module specified"); }
#line 3964 "cfg.tab.c"
    break;

  case 219: /* assign_stm: ALIAS EQUAL id_lst  */
#line 1127 "cfg.y"
                                      { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 3974 "cfg.tab.c"
    break;

  case 220: /* assign_stm: ALIAS EQUAL error  */
#line 1132 "cfg.y"
                                      { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 3981 "cfg.tab.c"
    break;

  case 221: /* assign_stm: AUTO_ALIASES EQUAL NUMBER  */
#line 1134 "cfg.y"
                                            { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 3988 "cfg.tab.c"
    break;

  case 222: /* assign_stm: AUTO_ALIASES EQUAL error  */
#line 1136 "cfg.y"
                                            { yyerror("number  expected"); }
#line 3994 "cfg.tab.c"
    break;

  case 223: /* assign_stm: ADVERTISED_ADDRESS EQUAL listen_id  */
#line 1137 "cfg.y"
                                                     { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address.s=(yyvsp[0].strval);
									default_global_address.len=strlen((yyvsp[0].strval));
								}
								}
#line 4005 "cfg.tab.c"
    break;

  case 224: /* assign_stm: ADVERTISED_ADDRESS EQUAL error  */
#line 1143 "cfg.y"
                                                 {yyerror("ip address or hostname "
												"expected"); }
#line 4012 "cfg.tab.c"
    break;

  case 225: /* assign_stm: ADVERTISED_PORT EQUAL NUMBER  */
#line 1145 "cfg.y"
                                               { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port.len)
									default_global_port.s =
									pkg_realloc(default_global_port.s, i_tmp);
								if (!default_global_port.s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port.len = i_tmp;
									memcpy(default_global_port.s, tmp,
											default_global_port.len);
								}
								}
#line 4031 "cfg.tab.c"
    break;

  case 226: /* assign_stm: ADVERTISED_PORT EQUAL error  */
#line 1159 "cfg.y"
                                             {yyerror("ip address or hostname "
												"expected"); }
#line 4038 "cfg.tab.c"
    break;

  case 227: /* assign_stm: DISABLE_CORE EQUAL NUMBER  */
#line 1161 "cfg.y"
                                            { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4046 "cfg.tab.c"
    break;

  case 228: /* assign_stm: DISABLE_CORE EQUAL error  */
#line 1164 "cfg.y"
                                           { yyerror("boolean value expected"); }
#line 4052 "cfg.tab.c"
    break;

  case 229: /* assign_stm: OPEN_FD_LIMIT EQUAL NUMBER  */
#line 1165 "cfg.y"
                                             { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4060 "cfg.tab.c"
    break;

  case 230: /* assign_stm: OPEN_FD_LIMIT EQUAL error  */
#line 1168 "cfg.y"
                                            { yyerror("number expected"); }
#line 4066 "cfg.tab.c"
    break;

  case 231: /* assign_stm: MCAST_LOOPBACK EQUAL NUMBER  */
#line 1169 "cfg.y"
                                              { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4078 "cfg.tab.c"
    break;

  case 232: /* assign_stm: MCAST_LOOPBACK EQUAL error  */
#line 1176 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4084 "cfg.tab.c"
    break;

  case 233: /* assign_stm: MCAST_TTL EQUAL NUMBER  */
#line 1177 "cfg.y"
                                         { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4096 "cfg.tab.c"
    break;

  case 234: /* assign_stm: MCAST_TTL EQUAL error  */
#line 1184 "cfg.y"
                                        { yyerror("number expected as tos"); }
#line 4102 "cfg.tab.c"
    break;

  case 235: /* assign_stm: TOS EQUAL NUMBER  */
#line 1185 "cfg.y"
                                   { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4111 "cfg.tab.c"
    break;

  case 236: /* assign_stm: TOS EQUAL ID  */
#line 1189 "cfg.y"
                               { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4144 "cfg.tab.c"
    break;

  case 237: /* assign_stm: TOS EQUAL error  */
#line 1217 "cfg.y"
                                  { yyerror("number expected"); }
#line 4150 "cfg.tab.c"
    break;

  case 238: /* assign_stm: MPATH EQUAL STRING  */
#line 1218 "cfg.y"
                                     {IFOR();
				set_mpath((yyvsp[0].strval)); }
#line 4157 "cfg.tab.c"
    break;

  case 239: /* assign_stm: MPATH EQUAL error  */
#line 1220 "cfg.y"
                                     { yyerror("string value expected"); }
#line 4163 "cfg.tab.c"
    break;

  case 240: /* assign_stm: DISABLE_DNS_FAILOVER EQUAL NUMBER  */
#line 1221 "cfg.y"
                                                    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4171 "cfg.tab.c"
    break;

  case 241: /* assign_stm: DISABLE_DNS_FAILOVER error  */
#line 1224 "cfg.y"
                                             { yyerror("boolean value expected"); }
#line 4177 "cfg.tab.c"
    break;

  case 242: /* assign_stm: DISABLE_DNS_BLACKLIST EQUAL NUMBER  */
#line 1225 "cfg.y"
                                                     { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4185 "cfg.tab.c"
    break;

  case 243: /* assign_stm: DISABLE_DNS_BLACKLIST error  */
#line 1228 "cfg.y"
                                              { yyerror("boolean value expected"); }
#line 4191 "cfg.tab.c"
    break;

  case 244: /* assign_stm: DST_BLACKLIST EQUAL ID COLON LBRACE blst_elem_list RBRACE  */
#line 1229 "cfg.y"
                                                                            { IFOR();
				s_tmp.s = (yyvsp[-4].strval);
				s_tmp.len = strlen((yyvsp[-4].strval));
				if (create_bl_head( BL_CORE_ID, BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4206 "cfg.tab.c"
    break;

  case 245: /* assign_stm: DISABLE_STATELESS_FWD EQUAL NUMBER  */
#line 1239 "cfg.y"
                                                     { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4213 "cfg.tab.c"
    break;

  case 246: /* assign_stm: DB_VERSION_TABLE EQUAL STRING  */
#line 1241 "cfg.y"
                                                { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4220 "cfg.tab.c"
    break;

  case 247: /* assign_stm: DB_VERSION_TABLE EQUAL error  */
#line 1243 "cfg.y"
                                               { yyerror("string value expected"); }
#line 4226 "cfg.tab.c"
    break;

  case 248: /* assign_stm: DB_DEFAULT_URL EQUAL STRING  */
#line 1244 "cfg.y"
                                              { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 4233 "cfg.tab.c"
    break;

  case 249: /* assign_stm: DB_DEFAULT_URL EQUAL error  */
#line 1246 "cfg.y"
                                             { yyerror("string value expected"); }
#line 4239 "cfg.tab.c"
    break;

  case 250: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL NUMBER  */
#line 1247 "cfg.y"
                                                        { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 4246 "cfg.tab.c"
    break;

  case 251: /* assign_stm: DB_MAX_ASYNC_CONNECTIONS EQUAL error  */
#line 1249 "cfg.y"
                                                       {
				yyerror("integer value expected");
				}
#line 4254 "cfg.tab.c"
    break;

  case 252: /* assign_stm: DISABLE_503_TRANSLATION EQUAL NUMBER  */
#line 1252 "cfg.y"
                                                       { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 4261 "cfg.tab.c"
    break;

  case 253: /* assign_stm: DISABLE_503_TRANSLATION EQUAL error  */
#line 1254 "cfg.y"
                                                      {
				yyerror("integer value expected");
				}
#line 4269 "cfg.tab.c"
    break;

  case 254: /* assign_stm: AUTO_SCALING_PROFILE EQUAL auto_scale_profile_def  */
#line 1257 "cfg.y"
                                                                    {}
#line 4275 "cfg.tab.c"
    break;

  case 255: /* assign_stm: AUTO_SCALING_PROFILE EQUAL error  */
#line 1258 "cfg.y"
                                                   {
				yyerror("bad auto-scaling profile definition");
				}
#line 4283 "cfg.tab.c"
    break;

  case 256: /* assign_stm: AUTO_SCALING_CYCLE EQUAL NUMBER  */
#line 1261 "cfg.y"
                                                  { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 4290 "cfg.tab.c"
    break;

  case 257: /* assign_stm: AUTO_SCALING_CYCLE EQUAL error  */
#line 1263 "cfg.y"
                                                 {
				yyerror("integer value expected");
				}
#line 4298 "cfg.tab.c"
    break;

  case 258: /* assign_stm: error EQUAL  */
#line 1266 "cfg.y"
                              { yyerror("unknown config variable"); }
#line 4304 "cfg.tab.c"
    break;

  case 259: /* module_stm: LOADMODULE STRING  */
#line 1269 "cfg.y"
                                        { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 4313 "cfg.tab.c"
    break;

  case 260: /* module_stm: LOADMODULE error  */
#line 1273 "cfg.y"
                                        { yyerror("string expected");  }
#line 4319 "cfg.tab.c"
    break;

  case 261: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 1274 "cfg.y"
                                                                          { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4330 "cfg.tab.c"
    break;

  case 262: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA snumber RPAREN  */
#line 1280 "cfg.y"
                                                                           { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 4341 "cfg.tab.c"
    break;

  case 263: /* module_stm: MODPARAM error  */
#line 1286 "cfg.y"
                                 { yyerror("Invalid arguments"); }
#line 4347 "cfg.tab.c"
    break;

  case 264: /* ip: ipv4  */
#line 1290 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4353 "cfg.tab.c"
    break;

  case 265: /* ip: ipv6  */
#line 1291 "cfg.y"
                       { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4359 "cfg.tab.c"
    break;

  case 266: /* ipv4: IPV4ADDR  */
#line 1294 "cfg.y"
                 {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 4378 "cfg.tab.c"
    break;

  case 267: /* ipv6addr: IPV6ADDR  */
#line 1310 "cfg.y"
                         {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 4397 "cfg.tab.c"
    break;

  case 268: /* ipv6: ipv6addr  */
#line 1326 "cfg.y"
                 { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 4403 "cfg.tab.c"
    break;

  case 269: /* ipv6: LBRACK ipv6addr RBRACK  */
#line 1327 "cfg.y"
                                 {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 4409 "cfg.tab.c"
    break;

  case 270: /* ipnet: IPNET  */
#line 1330 "cfg.y"
                {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 4420 "cfg.tab.c"
    break;

  case 271: /* ipnet: ip  */
#line 1336 "cfg.y"
                        {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 4429 "cfg.tab.c"
    break;

  case 272: /* folded_string: STRING STRING  */
#line 1346 "cfg.y"
                              {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4444 "cfg.tab.c"
    break;

  case 273: /* folded_string: folded_string STRING  */
#line 1356 "cfg.y"
                                       {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 4459 "cfg.tab.c"
    break;

  case 274: /* route_name: ID  */
#line 1367 "cfg.y"
                {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 4467 "cfg.tab.c"
    break;

  case 275: /* route_name: NUMBER  */
#line 1370 "cfg.y"
                         {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 4481 "cfg.tab.c"
    break;

  case 276: /* route_name: STRING  */
#line 1379 "cfg.y"
                        {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 4489 "cfg.tab.c"
    break;

  case 277: /* route_name_var: route_name  */
#line 1384 "cfg.y"
                           {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 4517 "cfg.tab.c"
    break;

  case 278: /* route_name_var: script_var  */
#line 1407 "cfg.y"
                             {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 4526 "cfg.tab.c"
    break;

  case 279: /* route_stm: ROUTE LBRACE actions RBRACE  */
#line 1412 "cfg.y"
                                        {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 4539 "cfg.tab.c"
    break;

  case 280: /* route_stm: ROUTE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1420 "cfg.y"
                                                                       {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 4560 "cfg.tab.c"
    break;

  case 281: /* route_stm: ROUTE error  */
#line 1436 "cfg.y"
                              { yyerror("invalid  route  statement"); }
#line 4566 "cfg.tab.c"
    break;

  case 282: /* failure_route_stm: ROUTE_FAILURE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1439 "cfg.y"
                                                                                {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 4577 "cfg.tab.c"
    break;

  case 283: /* failure_route_stm: ROUTE_FAILURE error  */
#line 1445 "cfg.y"
                                      { yyerror("invalid failure_route statement"); }
#line 4583 "cfg.tab.c"
    break;

  case 284: /* onreply_route_stm: ROUTE_ONREPLY LBRACE actions RBRACE  */
#line 1448 "cfg.y"
                                                       {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 4596 "cfg.tab.c"
    break;

  case 285: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1456 "cfg.y"
                                                                               {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 4607 "cfg.tab.c"
    break;

  case 286: /* onreply_route_stm: ROUTE_ONREPLY error  */
#line 1462 "cfg.y"
                                      { yyerror("invalid onreply_route statement"); }
#line 4613 "cfg.tab.c"
    break;

  case 287: /* branch_route_stm: ROUTE_BRANCH LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1465 "cfg.y"
                                                                              {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 4624 "cfg.tab.c"
    break;

  case 288: /* branch_route_stm: ROUTE_BRANCH error  */
#line 1471 "cfg.y"
                                     { yyerror("invalid branch_route statement"); }
#line 4630 "cfg.tab.c"
    break;

  case 289: /* error_route_stm: ROUTE_ERROR LBRACE actions RBRACE  */
#line 1474 "cfg.y"
                                                    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 4643 "cfg.tab.c"
    break;

  case 290: /* error_route_stm: ROUTE_ERROR error  */
#line 1482 "cfg.y"
                                    { yyerror("invalid error_route statement"); }
#line 4649 "cfg.tab.c"
    break;

  case 291: /* local_route_stm: ROUTE_LOCAL LBRACE actions RBRACE  */
#line 1485 "cfg.y"
                                                    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 4662 "cfg.tab.c"
    break;

  case 292: /* local_route_stm: ROUTE_LOCAL error  */
#line 1493 "cfg.y"
                                    { yyerror("invalid local_route statement"); }
#line 4668 "cfg.tab.c"
    break;

  case 293: /* startup_route_stm: ROUTE_STARTUP LBRACE actions RBRACE  */
#line 1496 "cfg.y"
                                                        {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 4681 "cfg.tab.c"
    break;

  case 294: /* startup_route_stm: ROUTE_STARTUP error  */
#line 1504 "cfg.y"
                                      { yyerror("invalid startup_route statement"); }
#line 4687 "cfg.tab.c"
    break;

  case 295: /* timer_route_stm: ROUTE_TIMER LBRACK route_name COMMA NUMBER RBRACK LBRACE actions RBRACE  */
#line 1507 "cfg.y"
                                                                                          {
						i_tmp = 0;
						while(sroutes->timer[i_tmp].a!=0 && i_tmp<TIMER_RT_NO){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 4704 "cfg.tab.c"
    break;

  case 296: /* timer_route_stm: ROUTE_TIMER error  */
#line 1519 "cfg.y"
                                    { yyerror("invalid timer_route statement"); }
#line 4710 "cfg.tab.c"
    break;

  case 297: /* event_route_stm: ROUTE_EVENT LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 1522 "cfg.y"
                                                                            {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 4721 "cfg.tab.c"
    break;

  case 298: /* event_route_stm: ROUTE_EVENT error  */
#line 1528 "cfg.y"
                                    { yyerror("invalid event_route statement"); }
#line 4727 "cfg.tab.c"
    break;

  case 299: /* exp: exp AND exp  */
#line 1533 "cfg.y"
                        { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4733 "cfg.tab.c"
    break;

  case 300: /* exp: exp OR exp  */
#line 1534 "cfg.y"
                                { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 4739 "cfg.tab.c"
    break;

  case 301: /* exp: NOT exp  */
#line 1535 "cfg.y"
                                        { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 4745 "cfg.tab.c"
    break;

  case 302: /* exp: LPAREN exp RPAREN  */
#line 1536 "cfg.y"
                                { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 4751 "cfg.tab.c"
    break;

  case 303: /* exp: LBRACK assignexp RBRACK  */
#line 1537 "cfg.y"
                                  { (yyval.expr)=(yyvsp[-1].expr); }
#line 4757 "cfg.tab.c"
    break;

  case 304: /* exp: exp_elem  */
#line 1538 "cfg.y"
                                        { (yyval.expr)=(yyvsp[0].expr); }
#line 4763 "cfg.tab.c"
    break;

  case 305: /* equalop: EQUAL_T  */
#line 1541 "cfg.y"
                          {(yyval.intval)=EQUAL_OP; }
#line 4769 "cfg.tab.c"
    break;

  case 306: /* equalop: DIFF  */
#line 1542 "cfg.y"
                                {(yyval.intval)=DIFF_OP; }
#line 4775 "cfg.tab.c"
    break;

  case 307: /* compop: GT  */
#line 1545 "cfg.y"
                {(yyval.intval)=GT_OP; }
#line 4781 "cfg.tab.c"
    break;

  case 308: /* compop: LT  */
#line 1546 "cfg.y"
                        {(yyval.intval)=LT_OP; }
#line 4787 "cfg.tab.c"
    break;

  case 309: /* compop: GTE  */
#line 1547 "cfg.y"
                        {(yyval.intval)=GTE_OP; }
#line 4793 "cfg.tab.c"
    break;

  case 310: /* compop: LTE  */
#line 1548 "cfg.y"
                        {(yyval.intval)=LTE_OP; }
#line 4799 "cfg.tab.c"
    break;

  case 311: /* matchop: MATCH  */
#line 1550 "cfg.y"
                {(yyval.intval)=MATCH_OP; }
#line 4805 "cfg.tab.c"
    break;

  case 312: /* matchop: NOTMATCH  */
#line 1551 "cfg.y"
                                {(yyval.intval)=NOTMATCH_OP; }
#line 4811 "cfg.tab.c"
    break;

  case 313: /* intop: equalop  */
#line 1554 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 4817 "cfg.tab.c"
    break;

  case 314: /* intop: compop  */
#line 1555 "cfg.y"
                        {(yyval.intval)=(yyvsp[0].intval); }
#line 4823 "cfg.tab.c"
    break;

  case 315: /* strop: equalop  */
#line 1558 "cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 4829 "cfg.tab.c"
    break;

  case 316: /* strop: compop  */
#line 1559 "cfg.y"
                     {(yyval.intval)=(yyvsp[0].intval); }
#line 4835 "cfg.tab.c"
    break;

  case 317: /* strop: matchop  */
#line 1560 "cfg.y"
                                {(yyval.intval)=(yyvsp[0].intval); }
#line 4841 "cfg.tab.c"
    break;

  case 318: /* script_var: SCRIPTVAR  */
#line 1563 "cfg.y"
                                {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 4862 "cfg.tab.c"
    break;

  case 319: /* script_var: SCRIPTVARERR  */
#line 1579 "cfg.y"
                               {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 4870 "cfg.tab.c"
    break;

  case 320: /* exp_elem: exp_cond  */
#line 1584 "cfg.y"
                                {(yyval.expr)=(yyvsp[0].expr); }
#line 4876 "cfg.tab.c"
    break;

  case 321: /* exp_elem: exp_stm  */
#line 1585 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 4882 "cfg.tab.c"
    break;

  case 322: /* exp_elem: snumber  */
#line 1586 "cfg.y"
                                        {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 4889 "cfg.tab.c"
    break;

  case 323: /* exp_elem: script_var  */
#line 1588 "cfg.y"
                                {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 4897 "cfg.tab.c"
    break;

  case 324: /* exp_cond: script_var strop script_var  */
#line 1593 "cfg.y"
                                      {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 4905 "cfg.tab.c"
    break;

  case 325: /* exp_cond: script_var strop STRING  */
#line 1596 "cfg.y"
                                          {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 4913 "cfg.tab.c"
    break;

  case 326: /* exp_cond: script_var intop snumber  */
#line 1599 "cfg.y"
                                           {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 4921 "cfg.tab.c"
    break;

  case 327: /* exp_cond: script_var equalop NULLV  */
#line 1602 "cfg.y"
                                                {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 4929 "cfg.tab.c"
    break;

  case 328: /* exp_cond: script_var equalop ipnet  */
#line 1605 "cfg.y"
                                           {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 4937 "cfg.tab.c"
    break;

  case 329: /* assignop: EQUAL  */
#line 1611 "cfg.y"
              { (yyval.intval) = EQ_T; }
#line 4943 "cfg.tab.c"
    break;

  case 330: /* assignop: COLONEQ  */
#line 1612 "cfg.y"
                  { (yyval.intval) = COLONEQ_T; }
#line 4949 "cfg.tab.c"
    break;

  case 331: /* assignop: PLUSEQ  */
#line 1613 "cfg.y"
                 { (yyval.intval) = PLUSEQ_T; }
#line 4955 "cfg.tab.c"
    break;

  case 332: /* assignop: MINUSEQ  */
#line 1614 "cfg.y"
                  { (yyval.intval) = MINUSEQ_T;}
#line 4961 "cfg.tab.c"
    break;

  case 333: /* assignop: SLASHEQ  */
#line 1615 "cfg.y"
                  { (yyval.intval) = DIVEQ_T; }
#line 4967 "cfg.tab.c"
    break;

  case 334: /* assignop: MULTEQ  */
#line 1616 "cfg.y"
                 { (yyval.intval) = MULTEQ_T; }
#line 4973 "cfg.tab.c"
    break;

  case 335: /* assignop: MODULOEQ  */
#line 1617 "cfg.y"
                   { (yyval.intval) = MODULOEQ_T; }
#line 4979 "cfg.tab.c"
    break;

  case 336: /* assignop: BANDEQ  */
#line 1618 "cfg.y"
                 { (yyval.intval) = BANDEQ_T; }
#line 4985 "cfg.tab.c"
    break;

  case 337: /* assignop: BOREQ  */
#line 1619 "cfg.y"
                { (yyval.intval) = BOREQ_T; }
#line 4991 "cfg.tab.c"
    break;

  case 338: /* assignop: BXOREQ  */
#line 1620 "cfg.y"
                 { (yyval.intval) = BXOREQ_T; }
#line 4997 "cfg.tab.c"
    break;

  case 339: /* assignexp: snumber  */
#line 1624 "cfg.y"
                { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5003 "cfg.tab.c"
    break;

  case 340: /* assignexp: STRING  */
#line 1625 "cfg.y"
                 { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5009 "cfg.tab.c"
    break;

  case 341: /* assignexp: script_var  */
#line 1626 "cfg.y"
                     { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5015 "cfg.tab.c"
    break;

  case 342: /* assignexp: exp_cond  */
#line 1627 "cfg.y"
                   { (yyval.expr)= (yyvsp[0].expr); }
#line 5021 "cfg.tab.c"
    break;

  case 343: /* assignexp: cmd  */
#line 1628 "cfg.y"
              { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5027 "cfg.tab.c"
    break;

  case 344: /* assignexp: assignexp PLUS assignexp  */
#line 1629 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5035 "cfg.tab.c"
    break;

  case 345: /* assignexp: assignexp MINUS assignexp  */
#line 1632 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5043 "cfg.tab.c"
    break;

  case 346: /* assignexp: assignexp MULT assignexp  */
#line 1635 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5051 "cfg.tab.c"
    break;

  case 347: /* assignexp: assignexp SLASH assignexp  */
#line 1638 "cfg.y"
                                    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5059 "cfg.tab.c"
    break;

  case 348: /* assignexp: assignexp MODULO assignexp  */
#line 1641 "cfg.y"
                                     {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5067 "cfg.tab.c"
    break;

  case 349: /* assignexp: assignexp BAND assignexp  */
#line 1644 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5075 "cfg.tab.c"
    break;

  case 350: /* assignexp: assignexp BOR assignexp  */
#line 1647 "cfg.y"
                                  {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5083 "cfg.tab.c"
    break;

  case 351: /* assignexp: assignexp BXOR assignexp  */
#line 1650 "cfg.y"
                                   {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5091 "cfg.tab.c"
    break;

  case 352: /* assignexp: assignexp BLSHIFT assignexp  */
#line 1653 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5099 "cfg.tab.c"
    break;

  case 353: /* assignexp: assignexp BRSHIFT assignexp  */
#line 1656 "cfg.y"
                                      {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5107 "cfg.tab.c"
    break;

  case 354: /* assignexp: BNOT assignexp  */
#line 1659 "cfg.y"
                         {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5115 "cfg.tab.c"
    break;

  case 355: /* assignexp: LPAREN assignexp RPAREN  */
#line 1662 "cfg.y"
                                  { (yyval.expr) = (yyvsp[-1].expr); }
#line 5121 "cfg.tab.c"
    break;

  case 356: /* assign_cmd: script_var assignop assignexp  */
#line 1665 "cfg.y"
                                          {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5139 "cfg.tab.c"
    break;

  case 357: /* assign_cmd: script_var EQUAL NULLV  */
#line 1678 "cfg.y"
                                  {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5157 "cfg.tab.c"
    break;

  case 358: /* assign_cmd: script_var COLONEQ NULLV  */
#line 1691 "cfg.y"
                                    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			/* not all can get NULL with := */
			switch((yyvsp[-2].specval)->type) {
				case PVT_AVP:
				break;
				default:
					yyerror("invalid left operand in NULL assignment");
			}
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5182 "cfg.tab.c"
    break;

  case 359: /* exp_stm: cmd  */
#line 1713 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5188 "cfg.tab.c"
    break;

  case 360: /* exp_stm: if_cmd  */
#line 1714 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5194 "cfg.tab.c"
    break;

  case 361: /* exp_stm: assign_cmd  */
#line 1715 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5200 "cfg.tab.c"
    break;

  case 362: /* exp_stm: LBRACE actions RBRACE  */
#line 1716 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5206 "cfg.tab.c"
    break;

  case 363: /* exp_stm: LBRACE RBRACE  */
#line 1717 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5212 "cfg.tab.c"
    break;

  case 364: /* brk_stm: brk_action  */
#line 1720 "cfg.y"
                                                                { (yyval.action)=(yyvsp[0].action); }
#line 5218 "cfg.tab.c"
    break;

  case 365: /* brk_stm: LBRACE brk_actions RBRACE  */
#line 1721 "cfg.y"
                                                        { (yyval.action)=(yyvsp[-1].action); }
#line 5224 "cfg.tab.c"
    break;

  case 366: /* brk_stm: LBRACE RBRACE  */
#line 1722 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5230 "cfg.tab.c"
    break;

  case 367: /* stm: action  */
#line 1725 "cfg.y"
                                                        { (yyval.action)=(yyvsp[0].action); }
#line 5236 "cfg.tab.c"
    break;

  case 368: /* stm: LBRACE actions RBRACE  */
#line 1726 "cfg.y"
                                                { (yyval.action)=(yyvsp[-1].action); }
#line 5242 "cfg.tab.c"
    break;

  case 369: /* stm: LBRACE RBRACE  */
#line 1727 "cfg.y"
                                                        { (yyval.action)=0; }
#line 5248 "cfg.tab.c"
    break;

  case 370: /* actions: actions action  */
#line 1730 "cfg.y"
                                {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5254 "cfg.tab.c"
    break;

  case 371: /* actions: action  */
#line 1731 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5260 "cfg.tab.c"
    break;

  case 372: /* actions: actions error  */
#line 1732 "cfg.y"
                                { (yyval.action)=0; yyerror("bad command!)"); }
#line 5266 "cfg.tab.c"
    break;

  case 373: /* brk_actions: brk_actions brk_action  */
#line 1736 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5272 "cfg.tab.c"
    break;

  case 374: /* brk_actions: brk_action  */
#line 1737 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5278 "cfg.tab.c"
    break;

  case 375: /* brk_actions: brk_actions error  */
#line 1738 "cfg.y"
                                    { (yyval.action)=0; yyerror("bad command!)"); }
#line 5284 "cfg.tab.c"
    break;

  case 376: /* action: cmd SEMICOLON  */
#line 1741 "cfg.y"
                              {(yyval.action)=(yyvsp[-1].action);}
#line 5290 "cfg.tab.c"
    break;

  case 377: /* action: if_cmd  */
#line 1742 "cfg.y"
                         {(yyval.action)=(yyvsp[0].action);}
#line 5296 "cfg.tab.c"
    break;

  case 378: /* action: while_cmd  */
#line 1743 "cfg.y"
                            {(yyval.action)=(yyvsp[0].action);}
#line 5302 "cfg.tab.c"
    break;

  case 379: /* action: foreach_cmd  */
#line 1744 "cfg.y"
                              {(yyval.action)=(yyvsp[0].action);}
#line 5308 "cfg.tab.c"
    break;

  case 380: /* action: switch_cmd  */
#line 1745 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5314 "cfg.tab.c"
    break;

  case 381: /* action: assign_cmd SEMICOLON  */
#line 1746 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 5320 "cfg.tab.c"
    break;

  case 382: /* action: SEMICOLON  */
#line 1747 "cfg.y"
                                              {(yyval.action)=0;}
#line 5326 "cfg.tab.c"
    break;

  case 383: /* action: cmd error  */
#line 1748 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5332 "cfg.tab.c"
    break;

  case 384: /* brk_action: BREAK SEMICOLON  */
#line 1751 "cfg.y"
                            { mk_action0((yyval.action), BREAK_T);}
#line 5338 "cfg.tab.c"
    break;

  case 385: /* brk_action: cmd SEMICOLON  */
#line 1752 "cfg.y"
                                {(yyval.action)=(yyvsp[-1].action);}
#line 5344 "cfg.tab.c"
    break;

  case 386: /* brk_action: brk_if_cmd  */
#line 1753 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5350 "cfg.tab.c"
    break;

  case 387: /* brk_action: while_cmd  */
#line 1754 "cfg.y"
                            {(yyval.action)=(yyvsp[0].action);}
#line 5356 "cfg.tab.c"
    break;

  case 388: /* brk_action: foreach_cmd  */
#line 1755 "cfg.y"
                              {(yyval.action)=(yyvsp[0].action);}
#line 5362 "cfg.tab.c"
    break;

  case 389: /* brk_action: switch_cmd  */
#line 1756 "cfg.y"
                             {(yyval.action)=(yyvsp[0].action);}
#line 5368 "cfg.tab.c"
    break;

  case 390: /* brk_action: assign_cmd SEMICOLON  */
#line 1757 "cfg.y"
                                       {(yyval.action)=(yyvsp[-1].action);}
#line 5374 "cfg.tab.c"
    break;

  case 391: /* brk_action: SEMICOLON  */
#line 1758 "cfg.y"
                                              {(yyval.action)=0;}
#line 5380 "cfg.tab.c"
    break;

  case 392: /* brk_action: cmd error  */
#line 1759 "cfg.y"
                            { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 5386 "cfg.tab.c"
    break;

  case 393: /* brk_if_cmd: IF LPAREN exp RPAREN brk_stm  */
#line 1762 "cfg.y"
                                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5399 "cfg.tab.c"
    break;

  case 394: /* brk_if_cmd: IF LPAREN exp RPAREN brk_stm ELSE brk_stm  */
#line 1770 "cfg.y"
                                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5412 "cfg.tab.c"
    break;

  case 395: /* if_cmd: IF LPAREN exp RPAREN stm  */
#line 1780 "cfg.y"
                                                                        { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 5425 "cfg.tab.c"
    break;

  case 396: /* if_cmd: IF LPAREN exp RPAREN stm ELSE stm  */
#line 1788 "cfg.y"
                                                                { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 5438 "cfg.tab.c"
    break;

  case 397: /* while_cmd: WHILE LPAREN exp RPAREN brk_stm  */
#line 1798 "cfg.y"
                                                        { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 5449 "cfg.tab.c"
    break;

  case 398: /* foreach_cmd: FOR LPAREN script_var IN script_var RPAREN brk_stm  */
#line 1806 "cfg.y"
                                                                   {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 5470 "cfg.tab.c"
    break;

  case 399: /* switch_cmd: SWITCH LPAREN script_var RPAREN LBRACE switch_stm RBRACE  */
#line 1824 "cfg.y"
                                                                                        {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 5482 "cfg.tab.c"
    break;

  case 400: /* switch_stm: case_stms default_stm  */
#line 1833 "cfg.y"
                                  { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5488 "cfg.tab.c"
    break;

  case 401: /* switch_stm: case_stms  */
#line 1834 "cfg.y"
                                                { (yyval.action)=(yyvsp[0].action); }
#line 5494 "cfg.tab.c"
    break;

  case 402: /* case_stms: case_stms case_stm  */
#line 1836 "cfg.y"
                                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 5500 "cfg.tab.c"
    break;

  case 403: /* case_stms: case_stm  */
#line 1837 "cfg.y"
                                                {(yyval.action)=(yyvsp[0].action);}
#line 5506 "cfg.tab.c"
    break;

  case 404: /* case_stm: CASE snumber COLON brk_actions  */
#line 1840 "cfg.y"
                                         { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 5517 "cfg.tab.c"
    break;

  case 405: /* case_stm: CASE snumber COLON  */
#line 1846 "cfg.y"
                                     { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 5528 "cfg.tab.c"
    break;

  case 406: /* case_stm: CASE STRING COLON brk_actions  */
#line 1852 "cfg.y"
                                                { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 5539 "cfg.tab.c"
    break;

  case 407: /* case_stm: CASE STRING COLON  */
#line 1858 "cfg.y"
                                    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 5550 "cfg.tab.c"
    break;

  case 408: /* default_stm: DEFAULT COLON brk_actions  */
#line 1866 "cfg.y"
                                       { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 5558 "cfg.tab.c"
    break;

  case 409: /* default_stm: DEFAULT COLON  */
#line 1869 "cfg.y"
                                { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 5564 "cfg.tab.c"
    break;

  case 410: /* func_param: STRING  */
#line 1872 "cfg.y"
                   {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 5574 "cfg.tab.c"
    break;

  case 411: /* func_param: func_param COMMA STRING  */
#line 1877 "cfg.y"
                                          {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5589 "cfg.tab.c"
    break;

  case 412: /* func_param: COMMA  */
#line 1887 "cfg.y"
                        {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 5601 "cfg.tab.c"
    break;

  case 413: /* func_param: COMMA STRING  */
#line 1894 "cfg.y"
                               {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 5613 "cfg.tab.c"
    break;

  case 414: /* func_param: func_param COMMA  */
#line 1901 "cfg.y"
                                   {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 5628 "cfg.tab.c"
    break;

  case 415: /* func_param: snumber  */
#line 1911 "cfg.y"
                          {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 5638 "cfg.tab.c"
    break;

  case 416: /* func_param: COMMA snumber  */
#line 1916 "cfg.y"
                                {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 5650 "cfg.tab.c"
    break;

  case 417: /* func_param: func_param COMMA snumber  */
#line 1923 "cfg.y"
                                           {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5665 "cfg.tab.c"
    break;

  case 418: /* func_param: script_var  */
#line 1933 "cfg.y"
                             {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 5675 "cfg.tab.c"
    break;

  case 419: /* func_param: COMMA script_var  */
#line 1938 "cfg.y"
                                   {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 5687 "cfg.tab.c"
    break;

  case 420: /* func_param: func_param COMMA script_var  */
#line 1945 "cfg.y"
                                              {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 5702 "cfg.tab.c"
    break;

  case 421: /* route_param: STRING  */
#line 1957 "cfg.y"
                    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 5712 "cfg.tab.c"
    break;

  case 422: /* route_param: snumber  */
#line 1962 "cfg.y"
                          {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 5722 "cfg.tab.c"
    break;

  case 423: /* route_param: NULLV  */
#line 1967 "cfg.y"
                        {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 5732 "cfg.tab.c"
    break;

  case 424: /* route_param: script_var  */
#line 1972 "cfg.y"
                             {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 5742 "cfg.tab.c"
    break;

  case 425: /* route_param: route_param COMMA STRING  */
#line 1977 "cfg.y"
                                           {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5757 "cfg.tab.c"
    break;

  case 426: /* route_param: route_param COMMA snumber  */
#line 1987 "cfg.y"
                                            {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5772 "cfg.tab.c"
    break;

  case 427: /* route_param: route_param COMMA script_var  */
#line 1997 "cfg.y"
                                               {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5787 "cfg.tab.c"
    break;

  case 428: /* route_param: route_param COMMA NULLV  */
#line 2007 "cfg.y"
                                          {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 5802 "cfg.tab.c"
    break;

  case 429: /* async_func: ID LPAREN RPAREN  */
#line 2019 "cfg.y"
                             {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-2].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(cmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 5825 "cfg.tab.c"
    break;

  case 430: /* async_func: ID LPAREN func_param RPAREN  */
#line 2037 "cfg.y"
                                                      {
				cmd_tmp=(void*)find_mod_acmd_export_t((yyvsp[-3].strval));
				if (cmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data = cmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 5861 "cfg.tab.c"
    break;

  case 431: /* async_func: ID LPAREN error RPAREN  */
#line 2068 "cfg.y"
                                                 {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 5870 "cfg.tab.c"
    break;

  case 432: /* async_func: ID error  */
#line 2072 "cfg.y"
                                   {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 5879 "cfg.tab.c"
    break;

  case 433: /* cmd: ASSERT LPAREN exp COMMA STRING RPAREN  */
#line 2078 "cfg.y"
                                                 {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 5887 "cfg.tab.c"
    break;

  case 434: /* cmd: DROP  */
#line 2081 "cfg.y"
                                                 {mk_action0( (yyval.action), DROP_T); }
#line 5893 "cfg.tab.c"
    break;

  case 435: /* cmd: DROP LPAREN RPAREN  */
#line 2082 "cfg.y"
                                     {mk_action0( (yyval.action), DROP_T); }
#line 5899 "cfg.tab.c"
    break;

  case 436: /* cmd: EXIT  */
#line 2083 "cfg.y"
                                                 {mk_action0( (yyval.action), EXIT_T); }
#line 5905 "cfg.tab.c"
    break;

  case 437: /* cmd: EXIT LPAREN RPAREN  */
#line 2084 "cfg.y"
                                     {mk_action0( (yyval.action), EXIT_T); }
#line 5911 "cfg.tab.c"
    break;

  case 438: /* cmd: RETURN script_var  */
#line 2086 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 5917 "cfg.tab.c"
    break;

  case 439: /* cmd: RETURN LPAREN script_var RPAREN  */
#line 2088 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 5923 "cfg.tab.c"
    break;

  case 440: /* cmd: RETURN snumber  */
#line 2090 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 5929 "cfg.tab.c"
    break;

  case 441: /* cmd: RETURN LPAREN snumber RPAREN  */
#line 2092 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 5935 "cfg.tab.c"
    break;

  case 442: /* cmd: RETURN LPAREN RPAREN  */
#line 2094 "cfg.y"
                                                         {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 5941 "cfg.tab.c"
    break;

  case 443: /* cmd: RETURN  */
#line 2095 "cfg.y"
                                                 {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 5947 "cfg.tab.c"
    break;

  case 444: /* cmd: LOG_TOK LPAREN STRING RPAREN  */
#line 2096 "cfg.y"
                                                {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 5955 "cfg.tab.c"
    break;

  case 445: /* cmd: LOG_TOK LPAREN snumber COMMA STRING RPAREN  */
#line 2099 "cfg.y"
                                                                {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 5966 "cfg.tab.c"
    break;

  case 446: /* cmd: LOG_TOK error  */
#line 2105 "cfg.y"
                                { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 5972 "cfg.tab.c"
    break;

  case 447: /* cmd: LOG_TOK LPAREN error RPAREN  */
#line 2106 "cfg.y"
                                              { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 5979 "cfg.tab.c"
    break;

  case 448: /* cmd: ERROR LPAREN STRING COMMA STRING RPAREN  */
#line 2108 "cfg.y"
                                                          {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 5990 "cfg.tab.c"
    break;

  case 449: /* cmd: ERROR error  */
#line 2114 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 5996 "cfg.tab.c"
    break;

  case 450: /* cmd: ERROR LPAREN error RPAREN  */
#line 2115 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6003 "cfg.tab.c"
    break;

  case 451: /* cmd: ROUTE LPAREN route_name_var RPAREN  */
#line 2117 "cfg.y"
                                                        {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6011 "cfg.tab.c"
    break;

  case 452: /* cmd: ROUTE LPAREN route_name_var COMMA route_param RPAREN  */
#line 2121 "cfg.y"
                                                                        {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6034 "cfg.tab.c"
    break;

  case 453: /* cmd: ROUTE error  */
#line 2140 "cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6040 "cfg.tab.c"
    break;

  case 454: /* cmd: ROUTE LPAREN error RPAREN  */
#line 2141 "cfg.y"
                                            { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6047 "cfg.tab.c"
    break;

  case 455: /* cmd: ID LPAREN RPAREN  */
#line 2143 "cfg.y"
                                        {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6075 "cfg.tab.c"
    break;

  case 456: /* cmd: ID LPAREN func_param RPAREN  */
#line 2166 "cfg.y"
                                                {
								cmd_tmp=(void*)find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6116 "cfg.tab.c"
    break;

  case 457: /* cmd: ID LPAREN error RPAREN  */
#line 2202 "cfg.y"
                                         { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6123 "cfg.tab.c"
    break;

  case 458: /* cmd: ID error  */
#line 2204 "cfg.y"
                           { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6131 "cfg.tab.c"
    break;

  case 459: /* cmd: XDBG LPAREN STRING RPAREN  */
#line 2207 "cfg.y"
                                            {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6138 "cfg.tab.c"
    break;

  case 460: /* cmd: XDBG LPAREN folded_string RPAREN  */
#line 2209 "cfg.y"
                                                   {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6145 "cfg.tab.c"
    break;

  case 461: /* cmd: XLOG LPAREN STRING RPAREN  */
#line 2211 "cfg.y"
                                            {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6152 "cfg.tab.c"
    break;

  case 462: /* cmd: XLOG LPAREN folded_string RPAREN  */
#line 2213 "cfg.y"
                                                   {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6159 "cfg.tab.c"
    break;

  case 463: /* cmd: XLOG LPAREN STRING COMMA STRING RPAREN  */
#line 2215 "cfg.y"
                                                         {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6166 "cfg.tab.c"
    break;

  case 464: /* cmd: XLOG LPAREN STRING COMMA folded_string RPAREN  */
#line 2217 "cfg.y"
                                                                {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6173 "cfg.tab.c"
    break;

  case 465: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2219 "cfg.y"
                                                                        {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6184 "cfg.tab.c"
    break;

  case 466: /* cmd: ASYNC_TOKEN LPAREN async_func COMMA route_name COMMA NUMBER RPAREN  */
#line 2225 "cfg.y"
                                                                                     {
				i_tmp = get_script_route_idx( (yyvsp[-3].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, NUMBER_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)(long)i_tmp, (void*)(long)(yyvsp[-1].intval));
				}
#line 6195 "cfg.tab.c"
    break;

  case 467: /* cmd: LAUNCH_TOKEN LPAREN async_func COMMA route_name RPAREN  */
#line 2231 "cfg.y"
                                                                         {
				i_tmp = get_script_route_idx( (yyvsp[-1].strval), sroutes->request, RT_NO, 0);
				if (i_tmp==-1) yyerror("too many script routes");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-3].action), (void*)(long)i_tmp);
				}
#line 6206 "cfg.tab.c"
    break;

  case 468: /* cmd: LAUNCH_TOKEN LPAREN async_func RPAREN  */
#line 2237 "cfg.y"
                                                        {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, NUMBER_ST,
						(yyvsp[-1].action), (void*)(long)-1);
				}
#line 6215 "cfg.tab.c"
    break;


#line 6219 "cfg.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2244 "cfg.y"


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	s->flags |= param->flags;
	s->workers = param->workers;
	s->auto_scaling_profile = param->auto_scaling_profile;
	if (param->socket)
		set_listen_id_adv(s, param->socket->name, param->socket->port);
	s->tag = param->tag;
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
